c $Header: /usr/people/flittner/radtran/flatpsv/src/Rayphase.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
******************************************************************
      subroutine Rayphase(costh0,sinth0,costh,sinth,cosn,sinn,
     &nlos,mfi,rmatrx,iangle,aniso,gamma,np)

C
c rmatrx(m,n,k,iangle,j) is rayleigth scattering matrix for input 
c angle iangle,output angles theta(j) and delta phi.
c
c note that minus signs are used in cos of theta angles because
c phase matrix is computed using a theta angle of 0.0 for a 
c beam traveling straight up and L.O.S. are read-in in the 
c subroutine read ( which means that the beam traveling straight
c up is discribed by the los angle 180.0.
C      AMU = -cos(output angle)
C      ANU = sin(output angle)
C      AMUP = -cos(incident angle)
C      ANUP =  sin(incident angle)
C      AMUSQ = cos()cos()
C      AMUMU = -cos()cos(solar zenith angle)
C      AMUPS = cos(solar zenith angle)^2
C      COOSN = cos(phi_output - phi_input)
c
c last modified: Aug. 9, 1997...def
c purpose: Change the azimuth angle definition such that positive
c          is for CCW when looking down from above.  Like a standard
c          coordinate system.  This is done by changing the sign of
c          the sin(delta_phi) term.
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
c passed to Rayphase
      integer nlos,iangle,np,mfi
      real*8 costh(mlos),sinth(mlos),cosn(mfi),sinn(mfi)
      real*8 rmatrx(4,4,mfi,mlos,mlos),costh0,sinth0,gamma
      logical aniso
c aniso is switch for using anisotropic Rayleigh particales with
c anisotropy factor of gamma
c local
      integer j,k,k1,k2
      real*8 ANUP,AMUP,COOSN,SIIN,COPSI,rmat(4,4),SISQ,CFISQ,SIFI
      real*8 SFISQ,AMUMU,AMUSQ,AMUPS,AMU,ANU,const,f
c
      const=3.0d0/8.0d0/pi
      AMUP=-costh0
      ANUP=sinth0
      AMUPS=AMUP*AMUP
      if(aniso)then
         f=const*gamma/(1.0d0+2.0d0*gamma)
         const=const*(1.0d0-gamma)/(1.0d0+2.0d0*gamma)
c loop over output theta angle
         do 20 j=1,nlos
            AMU=-costh(j)
            ANU=sinth(j)
            AMUSQ=AMU*AMU
            AMUMU=AMU*AMUP
C Loop on relative azimuth angle
            DO 10 k=1,mfi
               COOSN=COSN(k)
               SIIN=-SINN(k)
               COPSI=ANU*ANUP+AMU*AMUP*COOSN
               SISQ=COPSI*COPSI
               CFISQ=COOSN*COOSN
               SIFI=COPSI*COOSN
               SFISQ=SIIN*SIIN
               rmat(1,1)=(SISQ)
               rmat(1,2)=(AMUSQ*SFISQ)
               rmat(1,3)=(AMU*COPSI*SIIN)
               rmat(1,4)=0.0D0
               rmat(2,1)=(AMUPS*SFISQ)
               rmat(2,2)=(CFISQ)
               rmat(2,3)=(-AMUP*COOSN*SIIN)
               rmat(2,4)=0.0D0
               rmat(3,1)=(-2.0D0*AMUP*COPSI*SIIN)
               rmat(3,2)=(2.0D0*AMU*COOSN*SIIN)
               rmat(3,3)=(-AMUMU*SFISQ+SIFI)
               rmat(3,4)=0.0D0
               rmat(4,1)=0.0D0
               rmat(4,2)=0.0D0
               rmat(4,3)=0.0D0
               rmat(4,4)=(AMUMU*SFISQ+SIFI)
c
               rmat(1,1)=const*rmat(1,1)
               rmat(1,2)=const*rmat(1,2)
               rmat(1,3)=const*rmat(1,3)
               rmat(2,1)=const*rmat(2,1)
               rmat(2,2)=const*rmat(2,2)
               rmat(2,3)=const*rmat(2,3)
               rmat(3,1)=const*rmat(3,1)
               rmat(3,2)=const*rmat(3,2)
               rmat(3,3)=const*rmat(3,3)
               rmat(4,4)=const*rmat(4,4)
               rmat(1,1)=rmat(1,1)+f
               rmat(1,2)=rmat(1,2)+f
               rmat(2,1)=rmat(2,1)+f
               rmat(2,2)=rmat(2,2)+f
c
               if(np.eq.1)then
                rmatrx(1,1,k,iangle,j)=0.5d0*(rmat(1,1)+rmat(1,2)+
     &                                        rmat(2,1)+rmat(2,2))
               else
	        do k1=1,np
                  do k2=1,np
                     rmatrx(k1,k2,k,iangle,j)=rmat(k1,k2)
                  enddo
                enddo
               endif
10          CONTINUE
20       CONTINUE
      else
c loop over output theta angle
         do 40 j=1,nlos
            AMU=-costh(j)
            ANU=sinth(j)
            AMUSQ=AMU*AMU
            AMUMU=AMU*AMUP
C Loop on relative azimuth angle
            DO 30 k=1,mfi
               COOSN=COSN(k)
               SIIN=SINN(k)
               COPSI=ANU*ANUP+AMU*AMUP*COOSN
               SISQ=COPSI*COPSI
               CFISQ=COOSN*COOSN
               SIFI=COPSI*COOSN
               SFISQ=SIIN*SIIN
               rmat(1,1)=(SISQ)
               rmat(1,2)=(AMUSQ*SFISQ)
               rmat(1,3)=(AMU*COPSI*SIIN)
               rmat(1,4)=0.0D0
               rmat(2,1)=(AMUPS*SFISQ)
               rmat(2,2)=(CFISQ)
               rmat(2,3)=(-AMUP*COOSN*SIIN)
               rmat(2,4)=0.0D0
               rmat(3,1)=(-2.0D0*AMUP*COPSI*SIIN)
               rmat(3,2)=(2.0D0*AMU*COOSN*SIIN)
               rmat(3,3)=(-AMUMU*SFISQ+SIFI)
               rmat(3,4)=0.0D0
               rmat(4,1)=0.0D0
               rmat(4,2)=0.0D0
               rmat(4,3)=0.0D0
               rmat(4,4)=(AMUMU*SFISQ+SIFI)
c
               rmat(1,1)=const*rmat(1,1)
               rmat(1,2)=const*rmat(1,2)
               rmat(1,3)=const*rmat(1,3)
               rmat(2,1)=const*rmat(2,1)
               rmat(2,2)=const*rmat(2,2)
               rmat(2,3)=const*rmat(2,3)
               rmat(3,1)=const*rmat(3,1)
               rmat(3,2)=const*rmat(3,2)
               rmat(3,3)=const*rmat(3,3)
               rmat(4,4)=const*rmat(4,4)
c
               if(np.eq.1)then
                rmatrx(1,1,k,iangle,j)=0.5d0*(rmat(1,1)+rmat(1,2)+
     &                                        rmat(2,1)+rmat(2,2))
               else
	        do k1=1,np
                  do k2=1,np
                     rmatrx(k1,k2,k,iangle,j)=rmat(k1,k2)
                  enddo
                enddo
               endif
30          CONTINUE
40       CONTINUE
      endif
      RETURN
      END
***********************************************************************
