c     Subroutine returns Warren BRDF.
C      from eqn's 5&6 of Warren et al., JGR, 1998
c
c last mod. Mar. 27, 2000...def
c purpose: add logical lnormed so do not have to call once before using.
c normalization will be done the first time it is called
c
	subroutine brdfice(mode,rho,thtinc,tht,phi)
	implicit double precision (a-h,o-z)
	real*4 rho,thtinc,tht,phi,sza,thvw
	dimension xnrm(91)
      logical lnormed
      data lnormed/.FALSE./
	data raddeg,dtht,dphi/.0174532D0,.0174532D0,.0349065D0/
c
	save xnrm,dtht,dphi,lnormed
c
	if(.not.lnormed)then
c  do normalization (THR = 1 at all SZA's)
	 do isza=0,66
	  xnrm(isza+1) = 0.
	  sza = isza
C	  csinc = cos(sza)
	  do thvw=0.5,89.5,1.
	   csvw = cos(thvw)
	   snvw = sin(thvw)
	   do azi=1.,179.,2.
	    csphi = cos(azi)
	    cs2phi = cos(2.*azi)
	    xnrm(isza+1) = xnrm(isza+1) +
     &		2.*brdflo(sza,thvw,csphi,cs2phi)*csvw*snvw*dtht*dphi
 	   enddo
	  enddo
	 ENDDO
	 do isza=67,90
	  xnrm(isza+1) = 0.
	  sza = isza
	  csinc = cos(sza)
	  do thvw=0.5,89.5,1.
	   csvw = cos(thvw)
	   snvw = sin(thvw)
	   do azi=1.,179.,2.
	    csphi = cos(azi)
	    cs2phi = cos(2.*azi)
	    xnrm(isza+1) = xnrm(isza+1) +
     &		2.*brdfhi(csinc,csvw,csphi,cs2phi)*csvw*snvw*dtht*dphi
 	   enddo
	  enddo
	 ENDDO
       lnormed=.TRUE.
	endif
	csinc = cos(thtinc)
	csvw = cos(tht)
	csphi = cos(phi)
	cs2phi = cos(2.*phi)
C
	is1 = thtinc+1
	if(csinc .lt. 0.39073d0)then   !  Warren parametrization 67 < SZA < 90
	 rho = brdfhi(csinc,csvw,csphi,cs2phi)/xnrm(is1)
	else
	 rho = brdflo(thtinc,tht,csphi,cs2phi)/xnrm(is1)
	endif
C
C
	return
	END
	
	double precision function brdfhi(csinc,csvw,csphi,cs2phi)
	implicit double precision (a-h,o-z)
	dimension b(3,4),a(4)
	data b/.9216d0,-.3758d0,1.0016d0,.1994d0,.7084d0,-1.8176d0,
     &	       .1234d0,2.0702d0,-4.9036d0,.0751d0,.8440d0,-2.2769d0/
C
	save b
C
	do i=1,4
	 a(i) = b(1,i) + b(2,i)*csinc + b(3,i)*csinc**2
	enddo
	c1 = a(1) + a(2)*(1.-csvw)
	c2 = a(3)*(1.-csvw)
	c3 = a(4)*(1.-csvw)
	brdfhi = c1 + c2*csphi + c3*cs2phi
	return
	END
	
	double precision function brdflo(thti,thtv,csphi,cs2phi)
	implicit double precision (a-h,o-z)
	real*4 thti,thtv
C   b is the inverse of the 1 -67  4489  matrix
C			    1  30  900
C			    1  67  4489
	dimension b(3,3),coef(3),r(3)
	data b/0.154639d0,1.25077d0,-0.405405d0,
     &		-7.46269d-3,-1.86265d-9,7.46269d-3,
     &	       7.69349d-5,-2.78629d-4,2.01694d-4/
        data r2/.9866d0/
C
	save r2,b
	csinc = cos(thti)
	csvw = cos(thtv)
	cphi = abs(csphi)
	fphi = csphi/cphi
C  start by assuming reciprocity
	brdflo = brdfhi(csvw,csinc,csphi,cs2phi)
	if(thtv.ge.67.)return
C  that still leaves gaps over the thti,thtv range
C   fill the thti<67,thtv<67 gap with a quadratic in thtv between the fixed
C   points at thtv=-67, thtv=30, and thtv=67 (for any given thti less than 67)
	r(1) = brdfhi(.39073d0,csinc,-cphi,cs2phi)  ! thtv=-67
	r(2) = r2
	r(3) = brdfhi(.39073d0,csinc,cphi,cs2phi) ! thtv=67
	do i=1,3
	 coef(i) = 0.
	 do j=1,3
	  coef(i) = coef(i) + b(j,i)*r(j)
	 enddo
	enddo
	brdflo = coef(1) + fphi*coef(2)*thtv + coef(3)*thtv**2
	return
	END
