c $Header: /usr/people/flittner/radtran/flatpsv/src/brdfmir.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
      subroutine brdfmir(tht,phi,tht0,phi0,refr,refi,p,
     & domega)
c
c calc the reflection matrix for a mirror surface using frenel reflectors
c
c The coordinate system used is the same as that in the main rt code.
c The x axis points in the 0 deg azimuth direction or the direction that
c the rays of light from the sun are headed.  The z axis points in
c toward the center of the earth.  The y axis is defined by the cross-
c product of z and x (right handed coordinate system).  Therefore, the
c positive phi direction is measured in the clockwise direction when
c looking down from above.
c
c phi  =  output azimuth relative to solar plane (radians)
c phi0 =   input azimuth relative to solar plane (radians)
c
c last modified: April 17, 1997...def
c purpose: Taken from brdfsea.f
c
c last modified: June 20, 1997...def
c purpose: Change the definitions of the input angles passed to SANGAA.
c
      implicit none
      include 'consts.cmn'
c
c passed
      real*8 tht,phi,tht0,phi0,refr,refi,p(4,4),domega
c local
      integer i,j
      complex*16 r1,r2
      real*8 amu0,amu,factor
      real*8 CALF0,C,S,C0,S0,XMNAA0,CPNMP,SPNMP
c
c compute the angles for this problem so we can rotate the scattering
c matrix from the scattering plane to the vertical plane
c
      amu0=cos(tht0*dr)
      amu=cos(tht*dr)
      CALL SANGAA(amu0,phi0,amu,phi,
     *            CALF0,C,S,C0,S0,XMNAA0,CPNMP,SPNMP)
c
c check to see if this is a specular reflection (xmnaa0=1.0)
c
      if(XMNAA0.ge.0.99999)then
c
c compute frenel reflection matrix elements, cosine of incidence angle=calf0 
c
        call frenel(refr,refi,CALF0,r1,r2)
c
c simple expression is just
c
        p(1,1)=dble(r2*conjg(r2))
        p(2,2)=dble(r1*conjg(r1))
        p(3,3)=0.5d0*dble(r1*conjg(r2)+r2*conjg(r1))
        p(4,4)=p(3,3)
        p(3,4)=-.5d0*dimag(r1*conjg(r2)-r2*conjg(r1))
        p(4,3)=-p(3,4)
c
c all other elements are zero
c
        p(1,2)=0.0d0
        p(1,3)=0.0d0
        p(1,4)=0.0d0
        p(2,1)=0.0d0
        p(2,3)=0.0d0
        p(2,4)=0.0d0
        p(3,1)=0.0d0
        p(3,2)=0.0d0
        p(4,1)=0.0d0
        p(4,2)=0.0d0
c
c multiply by factor to represent the sea reflectance
c
        factor=1.0d0/domega
        do i=1,4
           do j=1,4
              p(j,i)=factor*p(j,i)
           enddo
        enddo
      else
        do i=1,4
           do j=1,4
              p(j,i)=0.0d0
           enddo
        enddo
      endif
      return
      end
