c $Header: /usr/people/flittner/radtran/flatpsv/src/caerovmsmat.f,v 1.14 1999/08/16 18:59:07 flittner Exp flittner $
       subroutine caerovmsmat(nlos,np,Tfine,dmu,costh,sinth,
     &wavel,QS,thd,omega0,const,
     &vtheta,vphi,vcosth,vsinth,fmatrx,avgall,ovrinp,
     &prtfas,g,iflag)
c
c
c last modified: Nov. 18, 1996
c purpose: Add switch for Henyey-Greenstein phase function
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c
	implicit none
        include 'consts.cmn'
        include 'param.inc'
c constants passed from the calling program
	integer nlos,np
c values calculated before hand that will be used in calculations
	real*8 Tfine(nan,7),dmu(mlos),costh(mlos),sinth(mlos),
     &cpf(mlos),wavel,QS,thd(mlos),omega0,const
c passed in as inputs
        integer iflag
	logical avgall,ovrinp,prtfas
	real*8 vtheta,vphi,vcosth,vsinth,g
c arrays and other variables that will be used as work-space
        real*8 fmatrx(4,4,nfi,mlos,mlos)
c variables that are local to this subroutine
	logical avgfas
        real*8 aconst,dphi,delphi,sumphi,sumF
        real*8 AMUP,ANUP,AMU,ANU,phik,thet0i,thetj,dthjp,dthjm,sum
        integer i,k,m,n,j,is,ie
c compute the aerosol scattering matrix for view subroutine
        dphi=df/dr
c Aerosol phase function
        AMU=-vcosth
        ANU=vsinth
        thetj=vtheta
c will average over the input direction.  This is different than 
c what was done for the regular angles.  There the averaging was
c done over the output direction.  Should differ slightly, but 
c give close agreement.
        avgfas=avgall
        do i=1,nlos
c for lack of a better number, set delphi=180.0/(nfi-1), dthjm, and
c dthjp accordingly.
	   delphi=180.0d0/dble(nfi-1)
	   if(i.eq.1) then
             dthjm=thd(1)
           else
             dthjm=(thd(i)-thd(i-1))*0.5d0
           endif
           if(i.eq.nlos) then
             dthjp=180.0d0-thd(nlos)
           else
             dthjp=(thd(i+1)-thd(i))*0.5d0
           endif
           AMUP=-costh(i)
           ANUP=sinth(i)
           thet0i=thd(i)
c do first half of phi first
           do k=1,nfi
              phik=vphi-dble(k-1)*dphi
              call oneaerop(AMU,AMUP,ANU,ANUP,avgfas,ovrinp,const,
     &          delphi,dthjm,dthjp,phik,Tfine,thet0i,thetj,
     &		fmatrx(1,1,k,i,1),np,g,iflag)
              if(prtfas)then
                write(6,*)'aerosol ms matrix for view='
                write(6,*) thet0i,thetj,phik
                write(6,'(4(4(1PE13.4),/))')((fmatrx(m,n,k,1,i),
     &				n=1,4),m=1,4)
              endif
           enddo
c now do the other half of phi 
	   do k=1,nfi-2
	      phik=vphi-dble(nfi+k-1)*dphi
              call oneaerop(AMU,AMUP,ANU,ANUP,avgfas,ovrinp,const,
     &          delphi,dthjm,dthjp,phik,Tfine,thet0i,thetj,
     &		fmatrx(1,1,k,i,2),np,g,iflag)
              if(prtfas)then
                write(6,*)'aerosol ms matrix for view='
                write(6,*) thet0i,thetj,phik
                write(6,'(4(4(1PE13.4),/))')((fmatrx(m,n,k,2,i),
     &				n=1,4),m=1,4)
              endif
	   enddo
	enddo
c check the normalization by integrating over all input angles
c the result should be 1.0
        sum=0.0d0
        is=1
        if(np.gt.1)then
          ie=2
          sumF=2.0d0
        else
          ie=1
          sumF=1.0d0
        endif
        do i=1,nlos
           sumphi=0.0d0
           do k=1,nfi
              do n=is,ie
                 do m=is,ie
                    sumphi=sumphi+fmatrx(m,n,k,i,1)
                 enddo
              enddo
           enddo
           do k=1,nfi-2
              do n=is,ie
                 do m=is,ie
                    sumphi=sumphi+fmatrx(m,n,k,i,2)
                 enddo
              enddo
           enddo
           sum=sum+sumphi*df*dmu(i)
        enddo
c i=1
c j=input theta index
        aconst=omega0/sum*sumF
        do j=1,nlos
c k=output delta phi index
           do k=1,nfi
              do n=1,np
                 do m=1,np
                    fmatrx(m,n,k,j,1)=aconst*fmatrx(m,n,k,j,1)
                 enddo
              enddo
           enddo
        enddo
c i=2
c j=input theta index
        do j=1,nlos
c k=output delta phi index
           do k=1,nfi-2
              do n=1,np
                 do m=1,np
                    fmatrx(m,n,k,j,2)=aconst*fmatrx(m,n,k,j,2)
                 enddo
              enddo
           enddo
        enddo
        return
        end
C----------------------------------------------------------------------
