c $Header: /usr/people/flittner/radtran/flatpsv/src/compang.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
	subroutine compang(theta0,thetap,delphi,theta,phi,
     &		maxnphi,nphi)
c ---------------------------------------------------------------------
c
c program to compute theta and phi for constant single scattering
c angle of thetap relative to theta0.
c
c
c theta0=sun zenith angle
c thetap=degrees away from the solar zenith angle
c delphi=azimuthally symmetric spacing around the solar zenith at
c	 some angle thetap
c
c modified July 10, 1996...def
c purpose: use constants defined by consts.
c
c
	implicit none
        include 'consts.cmn'
c
	integer nphi,i,maxnphi
c
	real*8 theta0,thetap,phip,x,y,delphi
	real*8 theta(maxnphi),phi(maxnphi)
	real*8 sin0,cos0,sinthp,costhp,sinphip,cosphip,tanphi,costh
	real*8 firstphi,min
c
c
	min=1.0d-06
c
	sin0=sin(theta0*dr)
	cos0=cos(theta0*dr)
	sinthp=sin(thetap*dr)
	costhp=cos(thetap*dr)
	nphi=int(180.0/delphi)+1
	do 20 i=1,nphi
	   phip=(i-1)*delphi
	   sinphip=sin(phip*dr)
	   cosphip=cos(phip*dr)
	   costh=cos0*costhp
	   costh=costh-sin0*sinthp*cosphip
	   theta(i)=acos(costh)
	   theta(i)=theta(i)/dr
	   y=sinthp*sinphip
	   x=cos0*sinthp*cosphip
	   x=x+sin0*costhp
	   if((y.le.min).and.(y.ge.-min))then
	     if(x.gt.0.0)then
	       phi(i)=0.0
	     else
	       phi(i)=180.0
	     end if
	   else if((x.le.min).and.(x.ge.-min))then
	     if(y.gt.0.0)then
	       phi(i)=90.0
	     else
	       phi(i)=-90.0
	     end if
	   else
	     tanphi=y/x
	     phi(i)=atan(tanphi)
	     phi(i)=phi(i)/dr
	     firstphi=phi(i)
	     if((x.lt.0.0).and.(y.lt.0.0))then
	       phi(i)=phi(i)-180.0
	     else if((x.lt.0.0).and.(y.gt.0.0))then
	       phi(i)=phi(i)+180.0
	     end if
	   end if
c	    write(6,1000)theta(i),phi(i)
1000	format(1x,'theta=',f8.3,' phi=',f8.3)
20	continue
	return
	end
