c $Header: /usr/people/flittner/radtran/flatpsv/src/crotang.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
      subroutine crotang(XMYU,PHEE,XMYUS,PHEES,C,S,CS,SS,cpsis,cpsi,
     &c2alf)
c
c calculate the rotation angle from the scattering plane to the vertical
c plane.
c
C                                                                       !   0013
c     purpose: 
c     given the direction of the incident beam (XMYU,PHEE) and the
c     direction of the reflected beam (XMYUS,PHEES)
c     figures out the angles of the "mirror" wave facet and
c     calculates all the angles required for complete description of
c     the Stokes parameters reflection from this
c     (generally non-horizontali)  wave facet (rotational matrices )
c
c     special case:  nadir incience and/or zenith reflectance
c
C     input variables:                                                  !   0014
C                                                                       !   0015
C     XMYU  - cosine of the vertical angle of the incident beam         !   0016
C     PHEE  - azimuth of the incident beam                              !   0018
C     XMYUS - cosine of the vertical angle of the reflected beam        !   0019
C     PHEES - azimuth of the reflectance angle                          !   0021
C                                                                       !   0022
C     output variables:  (see chart 2 of the documentation)             !   0023
C                                                                       !   0024
C     C     -   COS(2*PSI)                                              !   0026
C     S     -   SIN(2*PSI)                                              !   0027
C     CS    -   COS(2*PSI')                                             !   0028
C     SS    -   SIN(2*PSI')                                             !   0029
C                                                                       !   0033
C                                                                       !   0036
c last modified: June 24, 1997
c purpose: Use absolute value of phee-phees in calculating sin(psi), sin(psip)
c          since we are interested in just the values of sin(psi), sin(psip)
c          and not psi,psip.
c
c last modified: June 25, 1997
c purpose: change sign involving cos(phees-phee)
c
c last mod. Apr. 29, 1998...def
c purpose: change if to be for absolute value. Also explicitly include
c the double precession in the constants (1.0d0, etc.)
c
      implicit none
c passed
      real*8 XMYU,PHEE,XMYUS,PHEES,CALF,C,S,CS,SS
c local
      real*8 C2ALF,S2ALF,SALF,CPSIS,SPSIS,CPSI,SPSI
      real*8 SINKR,COSKR
      external SINKR,COSKR
c
C====================================================================== !   0049
C                                                                       !   0052
      C2ALF = XMYU*XMYUS+SQRT(1.0d0-XMYU**2)*SQRT(1.0d0-XMYUS**2)*      !   0053
     *                     COSKR(PHEE-PHEES)                            !   0054
C====================================================================== !   0055
C                                                                       !   0057
      IF(abs(C2ALF).LT.0.999990)then
        S2ALF = SQRT(1.0d0 - C2ALF**2)
        CALF  = SQRT(0.5d0*(1.0d0+C2ALF))
        SALF  = SQRT(0.5d0*(1.0d0-C2ALF))
        CPSIS  = (XMYU*SQRT(1.0d0-XMYUS**2)-XMYUS*SQRT(1.-XMYU**2)*
     *           COSKR(PHEE - PHEES) )/S2ALF
c        SPSIS  = SQRT(1.0d0-XMYU**2)*SINKR(PHEES-PHEE)/S2ALF
        SPSIS  = SQRT(1.0d0-XMYU**2)*SINKR(abs(PHEES-PHEE))/S2ALF
        CS     = 2.0d0*CPSIS**2 - 1.0d0
        SS     = 2.0d0*CPSIS*SPSIS
        CPSI   = (XMYUS*SQRT(1.0d0-XMYU**2)-XMYU*SQRT(1.0d0-XMYUS**2)*
     *           COSKR(PHEE - PHEES) )/S2ALF
c        SPSI   = SQRT(1.0d0-XMYUS**2)*SINKR(PHEE-PHEES)/S2ALF
        SPSI   = SQRT(1.0d0-XMYUS**2)*SINKR(abs(PHEE-PHEES))/S2ALF
        C      = 2.0d0*CPSI**2 - 1.0d0
        S      = 2.0d0*CPSI*SPSI
      else
        IF(abs(XMYU).LT.0.99999)then
          C     = 1.0d0
          S     = 0.0d0
          CS    = 1.0d0
          SS    = 0.0d0
        else
          C     = COSKR(2.0d0*PHEE )
          S     = SINKR(2.0d0*PHEE )
          CS    = COSKR(2.0d0*PHEES)
          SS    = SINKR(2.0d0*PHEES)
        endif
      endif
      RETURN
      END
