c $Header: /usr/people/flittner/radtran/flatpsv/src/downitr.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
c ---------------------------------------------------------------------

      subroutine downitr(itest,ndownlos,esi0r,esingr,pal,dmu,ldown,
     &wa,wr,wc,Pf0mat,Pr0mat,Pc0mat,trans,nz,nlos,np,convrg,itlmax)

C PERFORMS THE DOWNWARD PASS OF THE GAUSS-SIDEL ITERATION SCHEME FOR
C AZIMUTH INDEPENDENT INTENSITY.
C ITEST - USED TO CHECK FOR CONVERGENCE, IF MORE THAN A 0.1% CHANGE
C         IN INTENSITY OCCURS BETWEEN THE CURRENT AND LAST ITERATION
C         ANOTHER ITERATION IS PERFORMED.
C NLOS2  - THE INDEX OF THE LINE OF SIGHT ANGLE CLOSEST TO BUT LESS THAN
C         90 DEGREES

      implicit none
      include 'consts.cmn'
      include 'param.inc'
c variables that are passed
      integer itest,ndownlos,nz,nlos,np,itlmax
      real*8 esi0r(4,mlos,maxnz),esingr(4,mlos,maxnz)
      real*8 pal(mlos,maxnz),dmu(mlos),trans(mlos,maxnz)
      real*8 Pf0mat(4,4,mlos,mlos),wa(maxnlayr),wr(maxnlayr)
      real*8 Pr0mat(4,4,mlos,mlos),wc(maxnlayr)
      real*8 Pc0mat(4,4,mlos,mlos),convrg
c variables that are local
      integer level,layer,labove,ilos,m,itm,it,itestl
      integer isa,iea,isl,iel,ic
      logical ldown
      real*8 enew(4),cfl1,cfl2,T,wal,wrl,c1,delt,wcl,bndry
c external
      integer chkconvrg
      external chkconvrg
c
c
C THE LEVEL IS SELECTED BY THE L DO LOOP, LAYER IS LL=L-1
C FOR L=2, LL=1 AND THIS IS THE FIRST LAYER. THE INCIDENT INTENSITIES
C          ARE ZERO AND THE TOTAL SCATTER IS SIMPLY THAT WHICH OCCURS
C          IN THE FIRST LAYER
C FOR ALL OTHER LAYERS THERE WILL BE A BOUNDARY TERM AND A TERM FOR 
C          SCATTERING WITHIN THE LAYER. IN A FLAT ATMOSPHERE MODEL
C          THIS BOUNDARY INTENSITY IS SIMPLY THE INTENSITY FROM THE
C          LEVEL DIRECTLY ABOVE IN THE SAME DIRECTION
C
C SET THE L.O.S SUCH THAT THETA=0,90(ILOS=1,NLOS2) FOR DOWNWARD INTENSITIES
C THIS THETA  IS THE OUTPUT DIRECTION FOR THE PHASE FUNCTION CALCULATIONS 
C IN THE INTEGRATION OF THE SOURCE FUNCTION
C
C JLOS IS USED FOR THE OUTPUT PHI DIRECTION
C
C FUNCTION SOURCE PERFORMS THE SOURCE TERM INTEGRATION
      if(ldown)then
        isa=1
        iea=ndownlos
        isl=2
        iel=nz
        ic=1
      else
        isa=ndownlos+1
        iea=nlos
        isl=nz-1
        iel=1
        ic=-1
      endif
      do 50 level=isl,iel,ic
c         layer=level-1
         if(ldown)then
           layer=level-1
         else
           layer=level
         endif
         labove=level-ic
         wal=wa(layer)
         wrl=wr(layer)
         wcl=wc(layer)
         if(wcl.gt.0.5)then
           itm=itlmax
         else
           itm=1
         endif
         it=1
         itestl=100
c         do while((it.le.itm).and.(itestl.eq.100))
         do while((it.le.itm))
            itestl=0
            do 40 ilos=isa,iea
               delt=pal(ilos,level)
               T=trans(ilos,level)
               c1=1.0d0-T
               cfl2=(1.0d0-c1/delt)
               cfl1=(c1-cfl2)
               call sourcer(level,layer,labove,ilos,esi0r,
     &dmu,wal,wrl,wcl,cfl1,cfl2,Pf0mat,Pr0mat,Pc0mat,nlos,np,enew)
c m=1
               bndry=esi0r(1,ilos,labove)-esingr(1,ilos,labove)
	       enew(1)=enew(1)+esingr(1,ilos,level)+T*bndry
               if(itestl.ne.100.and.enew(1).ne.0.0) then
                 m=1
                 itestl=chkconvrg(enew(1),esi0r(1,ilos,level),convrg,
     &level,ilos,m,ldown)
               end if
               esi0r(1,ilos,level)=enew(1)
c m=2
	       if(np.gt.1)then
                 bndry=esi0r(2,ilos,labove)-esingr(2,ilos,labove)
	         enew(2)=enew(2)+esingr(2,ilos,level)+T*bndry
                 if(itestl.ne.100.and.enew(2).ne.0.0) then
                   m=2
                   itestl=chkconvrg(enew(2),esi0r(2,ilos,level),convrg,
     &level,ilos,m,ldown)
                 end if
                 esi0r(2,ilos,level)=enew(2)
                 if(np.gt.2)then
                   bndry=esi0r(3,ilos,labove)-esingr(3,ilos,labove)
	           enew(3)=enew(3)+esingr(3,ilos,level)+T*bndry
                   if(np.gt.3)then
                     bndry=esi0r(4,ilos,labove)-esingr(4,ilos,labove)
	             enew(4)=enew(4)+esingr(4,ilos,level)+T*bndry
                   endif
                 endif
               endif
40          continue
            it=it+1
         enddo
50    continue 
      itest=itestl
      return
      end
c ---------------------------------------------------------------------
