c $Header: /usr/people/flittner/radtran/flatpsv/src/readin.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
c ---------------------------------------------------------------------

      subroutine readin(PfoFmatrx,ProFmatrx,z,pres,thd,th,sun,dt,
     &ndownlos,
     &costh,sinth,sflux,tf,tabs,tray,omega0,wavel,cpr0,
     &cpr,cpf0,cpf,fmatrx,rmatrx,nz,nlos,
     &npass,cosn,sinn,deltmu,dmu,aniso,
     &gamma,avgall,np,Tfine,
     &QS,wa,wr,
     &ttf,ttr,tto3,tth2o,aphasefile,ipseudo,
     &ttc,tc,cphasefile,omega0c,Tfinec,cmatrx,cpc0,PcoFmatrx,wc,cpc,QSc,
     &phi,isfc)

C Read all information cataloged by program atmstr.for:
C ttf= total optical depth from aerosols in the atmosphere
C ttr= total optical depth from rayleigh in the atmosphere
C tto3= total tau ozone
C tth2o= total optical depth from h2o in the atmosphere
C wavel= the wavelength (microns) in free space
C omega0= single scattering albedo for the aerosol
C theta(i)=  angles in degrees to be used in radiative transfer code
C      for incident and scattered angles 
C z(i)=height for level i (in km). layer i is between z(i) and z(i+1)
C      z(1)=top,  z(nz)=surface
C tf(i)=total aerosol optical depth (vertical) in layer i
C tray(i)=total rayleigh optical depth (vertical) in layer i
C tabs(i)=th2o(i)+to3(i)= total molecular absorbtion optical depth (vertical)
C       in layer i from o3 and h2o (and any other molecules in the future
C      e.g. oxygen)
c
c last modified: Nov. 12, 1996
c purpose: Pass switch for Henyey-Greenstein phase function to the
c subroutines for calculating the phase function
c
c last modified: July 22, 1997...def
c purpose: Change switch for HG phase function to flag for size
c          dist type.
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c last mod. Oct. 22, 1998...def
c purpose: Correct errors associated with changing useold from
c logical to integer.
c

      implicit none
      include 'consts.cmn'
      include 'param.inc'
      include 'catmdata.cmn'
      include 'caerphs.cmn'
      include 'ccldphs.cmn'
c variables that are passed
      integer nlos,ndownlos,npass,nz,np,ipseudo,isfc

      real*8 z(maxnz),dt(maxnlayr),PfoFmatrx(4,nfi,mlos),pres(maxnlayr),
     &ProFmatrx(4,nfi,mlos),
     &Tfine(nan,7),cpr(mlos),cpf(mlos),fmatrx(4,4,nfi,mlos,mlos),
     &rmatrx(4,4,nfi,mlos,mlos),
     &tf(maxnlayr), tabs(maxnlayr), tray(maxnlayr),
     &thd(mlos),th(mlos),costh(mlos),sinth(mlos),cosn(nfi),
     &sinn(nfi),sun,sflux(4),omega0,wavel,cpr0,cpf0,
     &deltmu(mlos),dmu(mlos),gamma,rho,wa(maxnlayr),
     &wr(maxnlayr)
      logical aniso,avgall
c for cloud
      character cphasefile*100
      real*8 ttc,tc(maxnlayr),omega0c,Tfinec(nan,7),
     &PcoFmatrx(4,nfi,mlos),cpc0,cmatrx(4,4,nfi,mlos,mlos),QSc,
     &wc(maxnlayr),cconst,cpc(mlos),phi(nfi)
c
c variables that are local
      integer nlayr,i,lay,k,j,n,m,one,ifwd
      real*8 rconst,aconst,
     &ttf,ttr,tto3,tth2o,
     &cossun,sinsun,cosphi,theta0,
     &QS,amup,delphi,td,constn,constnc,g
      character aphasefile*100
c
      real*8 sum,dist
      logical prtfas
      integer useoldcpf
c
      useoldcpf=1
      prtfas=.FALSE.
c
      one=1
      delphi=df/dr

      if(nz.gt.maxnz)then
         write(6,*)'readin. HEY, YOU NEED TO INCREASE THE NUMBER OF ',
     &            'LAYERS FROM',maxnz,' TO',nz
         stop
      endif
      nlayr=nz-1

      write(61,3001) 'NUMBER OF ANGLES',nlos
      write(61,3001) 'NUMBER OF LEVELS',nz
      write(61,3001) 'NUMBER OF LAYERS',nlayr
      write(61,3001) 'MAX NUMBER OF ITERATIONS',npass
      write(61,3001) 'DELTA PHI INCREMENT (degrees)',
     &                                    int(180./real(nfi-1))
      write(61,2100)

      write(61,*) ' OUTPUT FROM FLAT ATMOSPHERE SIMULATION '
      write(61,*)' SUMMARY OF ATMOSPHERIC PARAMETERS:'
      write(61,*)
      write(61,1000)'WAVELENGTH (um)',wavel
      write(61,1001)'TOTAL OPTICAL DEPTH',ttf+ttr+tto3+tth2o+ttc
      write(61,1001)'TOTAL AEROSOL OPTICAL DEPTH',ttf
      write(61,1001)'TOTAL RAYLEIGH OPTICAL DEPTH',ttr
      write(61,1001)'TOTAL OZONE OPTICAL DEPTH',tto3
      write(61,1001)'TOTAL WATER VAPOR OPTICAL DEPTH',tth2o
      write(61,1001)'TOTAL CLOUD OPTICAL DEPTH',ttc
      write(61,*)

      if(aerosol) then
         write(61,*)'          ***              AEROSOL MODEL ',
     &'USED             ***'
c now read same info from aphasefile file
         if(iflgaer.eq.6)then
           g=gaer
           omega0=w0aer
         endif
         call rdphas(aphasefile,Tfine,QS,omega0,constn,g,iflgaer)
      else
         omega0=0.0d0
         write(61,*)'             ***  ATMOSPHERE ASSUMED TO',
     &' BE FREE OF AEROSOLS  ***'
      endif
      write(61,1001)'OMEGA0',omega0
      write(61,*)
      if(cloud) then
         write(61,*)'             ***               CLOUD ',
     &'MODEL USED              ***'
c now read same info from cphasefile
         if(iflgcld.eq.6)then
           g=gcld
           omega0c=w0cld
         endif
         call rdphas(cphasefile,Tfinec,QSc,omega0c,constnc,g,iflgcld)
      else
         omega0c=0.0d0
         write(61,*)'             ***  ATMOSPHERE ASSUMED TO',
     &' BE FREE OF CLOUDS  ***'
      endif
      write(61,1001)'OMEGA0c',omega0c
      write(61,*)

C DETERMINE ANGLE CLOSEST TO BUT LESS THAN NINETY DEGREES. THIS INDEX
C IS USED TO SEPARATE BETWEEN THE UPWARD AND DOWNWARD CASES.
      do 10 i=1,nlos
         th(i)=thd(i)*dr
         costh(i)=dcos(th(i))
         sinth(i)=dsin(th(i))
         if(thd(i).lt.90.0)then
            ndownlos=i
         end if
10    continue
C CALCULATE MU INTERVALS USED IN INTEGRATIONS

      call mucomput(dmu,deltmu,ndownlos,th,nlos)

      cossun=dcos(sun*dr)
      sinsun=dsin(sun*dr)


      cosn(1)=1.0d0
      sinn(1)=0.0d0
      do 30 k=2,nfi-1
         phi(k)=dble(k-1)*delphi
         cosn(k)=dcos(phi(k)*dr)
         sinn(k)=dsin(phi(k)*dr)
30    continue
      cosn(nfi)=-1.0d0 
      sinn(nfi)=0.0d0 
      phi(nfi)=180.0d0
      cosn(nfi/2+1)=0.0d0 
      sinn(nfi/2+1)=1.0d0 
      phi(nfi/2+1)=90.0d0
c compute phase function for single scattering with energy normalization 
c constants.  
c
      ifwd=1
      dist=abs(cossun-costh(ifwd))
      do j=2,ndownlos
         if(dist.gt.abs(cossun-costh(j)))then
           ifwd=j
           dist=abs(cossun-costh(ifwd))
         endif
      enddo
      if(rayleigh) then 
         useoldcpf=1
         if(aniso) rho=2.0d0*gamma/(1.0d0+gamma)
         call Rayphase(cossun,sinsun,costh,sinth,cosn,sinn,nlos,nfi,
     &rmatrx,one,aniso,gamma,np)
         call compc(dmu,rmatrx,cpr0,nlos,one,np,
     &ifwd,useoldcpf)
c         j=1
c         k=2
cc
cc check the rotation matrix by comparing to rayleigh phase funciton
cc
c               write(6,*)'readin. ',acos(cossun)/dr,acos(costh(j))/dr
c               write(6,2200)((rmatrx(m,n,k,1,j),n=1,4),m=1,4)
c               write(6,*)(rmatrx(1,1,k,1,j)+rmatrx(2,1,k,1,j)+
c     &rmatrx(1,2,k,1,j)+rmatrx(2,2,k,1,j))*0.5
cc
cc compute the rotation angles for the scattering and verical planes
cc
c               call otherray(cossun,sinsun,costh(j),sinth(j),cosn(k),
c     &sinn(k))
c         j=nlos
c         k=2
cc
cc check the rotation matrix by comparing to rayleigh phase funciton
cc
c               write(6,*)'readin. ',acos(cossun)/dr,acos(costh(j))/dr
c               write(6,2200)((rmatrx(m,n,k,1,j),n=1,4),m=1,4)
c               write(6,*)(rmatrx(1,1,k,1,j)+rmatrx(2,1,k,1,j)+
c     &rmatrx(1,2,k,1,j)+rmatrx(2,2,k,1,j))*0.5
cc
cc compute the rotation angles for the scattering and verical planes
cc
c               call otherray(cossun,sinsun,costh(j),sinth(j),cosn(k),
c     &sinn(k))
         do j=1,nlos
            do k=1,nfi
               if((useoldcpf.eq.0).and.(j.eq.ifwd))then
                 if(k.eq.1)then
                   rconst=cpr0
                 else
                   rconst=1.0d0
                 endif
               else if(useoldcpf.eq.1)then
                 rconst=cpr0
               else if(useoldcpf.eq.2)then
                 if(np.eq.1)then
                   rconst=cpr0*rmatrx(1,1,k,1,j)*dmu(j)*df
                 else
                   rconst=cpr0*(rmatrx(1,1,k,1,j)+rmatrx(1,2,k,1,j)+
     &rmatrx(2,1,k,1,j)+rmatrx(2,2,k,1,j))*dmu(j)*df*0.5
                 endif
               endif
               do m=1,np
                  sum=rmatrx(m,1,k,1,j)*sflux(1)
                  do n=2,np
                     sum=sum+rmatrx(m,n,k,1,j)*sflux(n)
                  enddo
                  ProFmatrx(m,k,j)=rconst*sum
               enddo
            enddo
         enddo
      else
         do j=1,nlos
            do k=1,nfi
               do m=1,np
                  ProFmatrx(m,k,j)=0.0d0
               enddo
            enddo
         enddo
         cpr0=0.0d0
         do j=1,nlos
            cpr(j)=0.0d0
         enddo
         do i=1,nlos
            do j=1,nlos
               do k=1,nfi
                  do m=1,np
                     do n=1,np
                        rmatrx(n,m,k,j,i)=0.0d0
                     enddo
                  enddo
               enddo
            enddo
         enddo
      endif


      if(aerosol) then
         useoldcpf=1
         amup=-cossun
         write(6,*)'readin. CALCULATE THE Aerosol SOLAR SCATTERING',
     &' MATRIX'
         if(iflgaer.eq.6)g=gaer
         call Aerophase(amup,sinsun,costh,sinth,cosn,sinn,nlos,
     &Tfine,wavel,QS,fmatrx,one,sun,thd,delphi,avgall,np,constn,
     &g,iflgaer)
c         j=1
c         k=2
cc
cc check the rotation matrix by comparing to rayleigh phase funciton
cc
c               write(6,*)'readin. ',acos(cossun)/dr,acos(costh(j))/dr
c               write(6,2200)((fmatrx(m,n,k,1,j),n=1,4),m=1,4)
c               write(6,*)(fmatrx(1,1,k,1,j)+fmatrx(2,1,k,1,j)+
c     &fmatrx(1,2,k,1,j)+fmatrx(2,2,k,1,j))*0.5
         call compc(dmu,fmatrx,cpf0,nlos,one,np,ifwd,
     &useoldcpf)
         do j=1,nlos
            do k=1,nfi
               if((useoldcpf.eq.0).and.(j.eq.ifwd))then
                 if(k.eq.1)then
                   aconst=cpf0*omega0
                 else
                   aconst=1.0d0
                 endif
               else if(useoldcpf.eq.1)then
                 aconst=cpf0*omega0
               else if(useoldcpf.eq.2)then
                 if(np.eq.1)then
                   aconst=cpf0*fmatrx(1,1,k,1,j)*dmu(j)*df*omega0
                 else
                   aconst=cpf0*(fmatrx(1,1,k,1,j)+fmatrx(1,2,k,1,j)+
     &fmatrx(2,1,k,1,j)+fmatrx(2,2,k,1,j))*dmu(j)*df*omega0*0.5
                 endif
               endif
               do m=1,np
                  sum=fmatrx(m,1,k,1,j)*sflux(1)
                  do n=2,np
                     sum=sum+fmatrx(m,n,k,1,j)*sflux(n)
                  enddo
                  PfoFmatrx(m,k,j)=aconst*sum
               enddo
            enddo
         enddo
      else
         do j=1,nlos
            do k=1,nfi
               do m=1,np
                  PfoFmatrx(m,k,j)=0.0d0
               enddo
            enddo
         enddo
         cpf0=0.0d0
         do j=1,nlos
            cpf(j)=0.0d0
         enddo
         do i=1,nlos
            do j=1,nlos
               do k=1,nfi
                  do m=1,np
                     do n=1,np
                        fmatrx(n,m,k,j,i)=0.0d0
                     enddo
                  enddo
               enddo
            enddo
         enddo
      endif
      if(cloud) then
         useoldcpf=1
         amup=-cossun
         write(6,*)'readin. CALCULATE THE Cloud SOLAR SCATTERING MATRIX'
         if(iflgcld.eq.6)g=gcld
         call Aerophase(amup,sinsun,costh,sinth,cosn,sinn,nlos,
     &Tfinec,wavel,QSc,cmatrx,one,sun,thd,delphi,avgall,np,constnc,
     &g,iflgcld)
         call compc(dmu,cmatrx,cpc0,nlos,one,np,ifwd,
     &useoldcpf)
         do j=1,nlos
            do k=1,nfi
               if((useoldcpf.eq.0).and.(j.eq.ifwd))then
                 if(k.eq.1)then
                   cconst=cpc0*omega0c
                 else
                   cconst=1.0d0
                 endif
               else if(useoldcpf.eq.1)then
                 cconst=cpc0*omega0c
               else if(useoldcpf.eq.2)then
                 if(np.eq.1)then
                   cconst=cpc0*cmatrx(1,1,k,1,j)*dmu(j)*df*omega0c
                 else
                   cconst=cpc0*(cmatrx(1,1,k,1,j)+cmatrx(1,2,k,1,j)+
     &cmatrx(2,1,k,1,j)+cmatrx(2,2,k,1,j))*dmu(j)*df*omega0c*0.5
                 endif
               endif
C               write(6,*)'readin. cconst ',cconst/omega0c
               do m=1,np
                  sum=cmatrx(m,1,k,1,j)*sflux(1)
                  do n=2,np
                     sum=sum+cmatrx(m,n,k,1,j)*sflux(n)
                  enddo
                  PcoFmatrx(m,k,j)=cconst*sum
               enddo
            enddo
         enddo
      else
         do j=1,nlos
            do k=1,nfi
               do m=1,np
                  PcoFmatrx(m,k,j)=0.0d0
               enddo
            enddo
         enddo
         cpc0=0.0d0
         do j=1,nlos
            cpc(j)=0.0d0
         enddo
         do i=1,nlos
            do j=1,nlos
               do k=1,nfi
                  do m=1,np
                     do n=1,np
                        cmatrx(n,m,k,j,i)=0.0d0
                     enddo
                  enddo
               enddo
            enddo
         enddo
      endif

      do 40 lay=1,nlayr
         dt(lay)=tf(lay)+tray(lay)+tabs(lay)+tc(lay)
         td=1.0d0/dt(lay)
         wa(lay)=tf(lay)*td
         wr(lay)=tray(lay)*td
         wc(lay)=tc(lay)*td
40    continue

      if(npass.gt.0)then
c compute phase function for any angle of scattering
c with energy normalization constants.

        if(rayleigh) then
           write(6,*)'readin. CALCULATE THE Rayleigh MULTIPLE ',
     &'SCATTERING MATRIX'
           useoldcpf=1
           do 70 i=1,nlos
              call Rayphase(costh(i),sinth(i),costh,sinth,cosn,sinn,
     &nlos,nfi,rmatrx,i,aniso,gamma,np)
              if(prtfas)then
                write(6,*)'readin. rayleigh ms matrix for incident ',
     &'angle=',acos(costh(i))/dr
	        write(6,'(4(4(1PE13.4),/))')
     &(((rmatrx(m,n,k,i,nlos),n=1,4),m=1,4),k=1,nfi)
	      endif
              theta0=thd(i)
              ifwd=i
              call compc(dmu,rmatrx,cpr(i),nlos,i,np,
     &ifwd,useoldcpf)
              do j=1,nlos
                 do k=1,nfi
                    if((useoldcpf.eq.0).and.(j.eq.ifwd))then
                      if(k.eq.1)then
                        rconst=cpr(i)
                      else
                        rconst=1.0d0
                      endif
                    else if(useoldcpf.eq.1)then
                      rconst=cpr(i)
                    else if(useoldcpf.eq.2)then
                      if(np.eq.1)then
                        rconst=cpr(i)*rmatrx(1,1,k,i,j)*dmu(j)*df
                      else
                        rconst=cpr(i)*(rmatrx(1,1,k,i,j)+
     &rmatrx(1,2,k,i,j)+rmatrx(2,1,k,i,j)+rmatrx(2,2,k,i,j))*dmu(j)*df*0.5
                      endif
                    endif
                    do n=1,np
                       do m=1,np
                           rmatrx(m,n,k,i,j)=rmatrx(m,n,k,i,j)*rconst
                       enddo
                    enddo
                 enddo
              enddo
70         continue
        endif

        if(aerosol)then
           write(6,*)'readin. CALCULATE THE Aerosol MULTIPLE ',
     &'SCATTERING MATRIX'
           useoldcpf=1
           if(iflgaer.eq.6)g=gaer
	   call caeromsmat(costh,sinth,cosn,sinn,wavel,dmu,constn,
     &QS,thd,delphi,Tfine,cpf,fmatrx,omega0,np,nlos,avgall,useoldcpf,
     &g,iflgaer)
        endif

        if(cloud)then
           write(6,*)'readin. CALCULATE THE Cloud MULTIPLE SCATTERING ',
     &'MATRIX'
           useoldcpf=1
           if(iflgcld.eq.6)g=gcld
	   call caeromsmat(costh,sinth,cosn,sinn,wavel,dmu,constnc,
     &QSc,thd,delphi,Tfinec,cpc,cmatrx,omega0c,np,nlos,avgall,useoldcpf,
     &g,iflgcld)
        endif
      else
        do j=1,nlos
           cpr(j)=0.0d0
        enddo
        do i=1,nlos
           do j=1,nlos
              do k=1,nfi
                 do m=1,np
                    do n=1,np
                       rmatrx(n,m,nfi,mlos,mlos)=0.0d0
                    enddo
                 enddo
              enddo
           enddo
        enddo
        do j=1,nlos
           cpf(j)=0.0d0
        enddo
        do i=1,nlos
           do j=1,nlos
              do k=1,nfi
                 do m=1,np
                    do n=1,np
                       fmatrx(n,m,nfi,mlos,mlos)=0.0d0
                    enddo
                 enddo
              enddo
           enddo
        enddo
        do j=1,nlos
           cpc(j)=0.0d0
        enddo
        do i=1,nlos
           do j=1,nlos
              do k=1,nfi
                 do m=1,np
                    do n=1,np
                       cmatrx(n,m,nfi,mlos,mlos)=0.0d0
                    enddo
                 enddo
              enddo
           enddo
        enddo
      endif
      if(tto3+tth2o.lt.0.00001) then
         write(61,*)'      *** ATMOSPHERE ASSUMED TO BE FREE OF ',
     &'GASEOUS ABSORPTION ***'
      endif

      write(61,*)
      write(61,*)
      if(aniso)then      
         write(61,'(2x,a27,a31,1PE10.4)')'USING MOLECULAR ANISOTROPIC',
     &' DEPOLARIZATION FACTOR (rho) = ',rho
         write(61,'(2x,a33,F7.4)')'OR KING CORRECTION FACTOR (Fk) = ',
     &(6.0d0+3.0d0*rho)/(6.0d0-7.0d0*rho)
         write(61,*)
         write(61,*)
      endif
      write(61,*)'      ------- NORMALIZATION CONSTANTS FOR RAY',
     &'LEIGH, AEROSOL ------'
      write(61,*)'      ---------- AND CLOUD PHASE FUNCTION CAL',
     &'CULATIONS  ----------'
      write(61,4000)(i,thd(i),cpr(i),cpf(i),cpc(i),i=1,nlos) 
      write(61,4200)sun,cpr0,cpf0,cpc0
      write(61,*)'         ----------   HEIGHT LEVELS AND LAYER',
     &' OPTICAL DEPTHS  ----------'
c      write(61,2110)z(nz)
      write(61,4100)(i,z(i+1),pres(i),dt(i),tf(i),tray(i),tabs(i),tc(i),
     &i=1,nlayr)
      write(61,2100)
      write(61,*) ' SOLAR PARAMETERS'
      write(61,*)
      write(61,5100) 'SOLAR ZENITH ANGLE (degrees)',sun
      write(61,5110) 'INPUT SOLAR FLUX',(sflux(i),i=1,np)
      write(61,*)
      if(ipseudo.eq.0)then
        write(61,*)'Solar beam attenuated to the zenith as in a ',
     &'flat atmosphere.'
        write(61,*)'All subsequent pathlengths are for a flat ',
     &'atmosphere.'
      else if(ipseudo.eq.1)then
        write(61,*)'Solar beam attenuated to the zenith as in a ',
     &'spherical atmosphere.'
        write(61,*)'All subsequent pathlengths are for a flat ',
     &'atmosphere.'
      endif
      write(61,2100)


1000  format(12x,a31,1x,'= ',f9.5)
1001  format(12x,a31,1x,'= ',1PE9.3)
2000  format(9x,a41,1x,'=',1x,f8.5)
2100  format(/,/,78('*'))
2110  format('      ---------- (height of bottom level t',
     &'aken to be ',f6.2,' km) ----------')
2200  format(4(1P4e12.4,/))
3000  format(12x,a38,1x,'=',1x,f8.5)
3001  format(17x,a29,1x,'--',1x,i3)
4000  format(/,6x,'INDEX #',3x,'L.O.S. ANGLE',3x,'RAYLEIGH',
     &5x,'AEROSOL',7x,'CLOUD',//,
     &100(8x,i3,7x,f8.4,3f13.7,/))
4100  format(/,1x,'LAYER  LAYER BOTTOM',8x,'L A Y E R    ',
     &'O P T I C A L    D E P T H S',/,3x,'#',4x,'(km)',3x,'(mb)',
     &5x,'TOTAL',5x,'AEROSOL',4x,'RAYLEIGH',2x,'ABSORPTION',3x,
     &'CLOUD',/,78('*'),/,100(i5,f8.3,f8.2,5(E11.4),/))
4200  format(4x,'For Sun at',4x,f8.4,3f13.7,/)
5100  format(6x,a39,1x,'=',1x,f11.4)     
5110  format(6x,a39,1x,'=',3x,3(f6.4,','),f6.4)     


      return
      end

c ---------------------------------------------------------------------
