c $Header: /usr/people/flittner/radtran/flatpsv/src/useumkehr.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
C#######################################################################
       subroutine useumkehr(
     &NN,npr,zpres,pres,aer,oz,y2,zmaxmin,intpres,
     &totoz,totwat,sfcprs,ttc,ttf,ttr,tto3,tth2o)
c
c use the umkehr profile generated by C. Mateer to construct the atmopshere
c needed by the rte code.
c
       implicit none
c
       include 'cstdatm.cmn'
c passed
       integer npr,NN
       real*8 ttf,ttr,tto3,tth2o,ttc,zmaxmin
       real*8 sfcprs,totoz,totwat
       real*8 intpres(N)
       real*8 zpres(NN),pres(NN),oz(NN),y2(NN),aer(NN)
c local
      integer i,j,mode
      real*8 tmp(8,76),ln0_5,dz,dlnp,ypn,yp1,sum,totod
      character buf*1,fname*10
c
      ln0_5=log(0.5d0)
c
c open and read one line at a time
      fname='umkehr.prf'
      open(16,file=fname,status='old')
c skip the header
      do i=1,8
         read(16,'(a)')buf
      enddo
      npr=76
      do i=1,npr
         read(16,*)(tmp(j,i),j=1,8)
      enddo
      close(16)
c now create the cummulative optical depth arrays for ozone and rayleigh
c calculate the cummulative ozone and rayleigh opticals as function of z & p
      zpres(1)=tmp(3,1)
      pres(1)=exp(ln0_5*tmp(1,1))*1013.25d0
      aer(1)=(tmp(6,1))
      oz(1)=(tmp(5,1)*tmp(4,1))
      totoz=tmp(5,1)
      do i=1,npr
         zpres(i)=tmp(3,i)
         pres(i)=exp(ln0_5*tmp(1,i))*1013.25d0
         aer(i)=aer(i-1)+(tmp(6,i))
         oz(i)=oz(i-1)+(tmp(5,i)*tmp(4,i))
         totoz=totoz+tmp(5,i)
      enddo
c set the total values of pressure and od
      sfcprs=1013.25d0
      ttr=aer(npr)
      tto3=oz(npr)
      ttf=0.0d0
      tth2o=0.0d0
      ttc=0.0d0
      totwat=0.0d0
c readjust the top of the zstd array
      if(zmaxmin.gt.zpres(1))zmaxmin=zpres(1)
      i=1
      do while(zstd(i).lt.zmaxmin)
         i=i+1
      enddo
      nstd=i
c now interpolate to the standard z values, using "natrual" spline
      yp1=1.0d30
      ypn=1.0d30
      mode=2
      call spline(zpres,pres,npr,yp1,ypn,y2,mode)
      do i=1,nstd
         call splint(zpres,pres,y2,npr,zstd(i),intpres(i),mode)
      enddo
      mode=2
      call spline(zpres,aer,npr,yp1,ypn,y2,mode)
      do i=1,nstd
         call splint(zpres,aer,y2,npr,zstd(i),tauray(i),mode)
      enddo
      mode=2
      call spline(zpres,oz,npr,yp1,ypn,y2,mode)
      do i=1,nstd
         call splint(zpres,oz,y2,npr,zstd(i),tauo3(i),mode)
      enddo
c compute the total cummulative optical depth
      do i=1,nstd
         ttotal(i)=tauray(i)+tauo3(i)
      enddo
c zero-out the aerosol, water vapor and cloud ods
      call setzeros(tauf,N)
      call setzeros(tauc,N)
      call setzeros(tauh2o,N)
c calculate the scale height of rayleigh and ozone
      Hf=0.0d0
      Hh2o=0.0d0
      Hp=(dzstd(nstd-1))/log(tauray(nstd-1)/tauray(nstd))
      if(oz(nstd).ne.oz(nstd-1))then
c use scale height for ozone loading above level zstd(nstd)
        Ho3=(dzstd(nstd-1))/log(tauo3(nstd-1)/tauo3(nstd))
      else
        Ho3=0.0d0
      endif
c now return
      return
      end
c***********************************************************************
