c $Header: /usr/people/flittner/radtran/flatpsv/src/vsource.f,v 1.14 1999/08/16 18:59:07 flittner Exp flittner $
c ---------------------------------------------------------------------

      subroutine vsource(layer,lcurent,lprevious,nlos,np,
     & cf1,cf2,dmu,esi0,wal,wrl,wcl,fmatrx,rmatrx,cmatrx,vphi,enew)

C THE INTEGRAL OF THE SOURCE FUNCTION (DIFFUSE)
C (NOT INCLUDING SINGLE SCATTERING)
C OVER TAU IN LAYER LL FOR L.O.S ORIGINATING
C IN LEVEL LCURENT (OBSERVATION LEVEL) AT AN ANGLE VTHETA AND VPHI
C OUTPUT (ANGLE OF L.O.S) for the m polarization element.
C THE SOURCE FUNCTION IS P*I*DOMEGA (INTEGRATED OVER OMEGA)
C SOURCE= MULTIPLE SCATTERING INTENSITY ON SID=0 FROM  
C         THE INTEGRATED SOURCE FUNCTION  AT ITERATION IEND 
C SET THETA' (INPUT) FOR INTEGRATION OVER ALL PHI' (INPUTS) 
C NOFM = VARIABLE FOR INTEGRATION OVER PHI=0,360
C SET PHI' (INPUT)  (0,360). USE SYMMETRY & ANTISYMMETRY OF I34 AND P 
C FOR PHI'>180 IN CALCULATING source.
C F1 INTENSITY AT LEVEL L-1
C F2 IS INTENSITY AT LEVEL L  
C F IS THE INTEGRAL OF THE INTENSITY ALONG L.O.S BETWEEN LEVEL L-1 AND L
C     (I.E LAYER LL)
C P=THE PHASE FUNCTION FOR THE LAYER
C TRANSFORM INDEX KFMAT FOR AZIMUTH DIFERENCE IN phasems(I,J,KFMAT) IF THE 
C     AZIMUTH DIFFERENCE IS GREATER THAN 180 DEGREES.
C SUMMM IS THE INTEGRATION (OVER TAU) OF THE SOURCE FUNCTION
C     J(LAYER LL,THETA,PHI) IN THE LAYER, WHERE THE THE INTEGRATION WAS DONE
c M is the polarization vector element
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
c variables that are passed input this routine
	integer lcurent,layer,lprevious,nlos,np
	real*8 fmatrx(4,4,nfi,mlos,mlos),rmatrx(4,4,nfi,mlos,mlos),
     &cmatrx(4,4,nfi,mlos,mlos),wal,wrl,wcl,
     &		esi0(4,nfi,mlos,maxnz),dmu(mlos),
     &		cf1,cf2,vphi
c variables that are passed as output from this routine
	real*8 enew(4)
c variables that are local
	integer jprim,k,nn,n,m,nfip1
	real*8 f2,f1,f,ep(4),ec(4),pn(4,4),ddomeg
	logical cango
c
	cango=.FALSE.
c
c initialize enew vector
c
	do m=1,np
	  enew(m)=0.0d0
	enddo
	nfip1=nfi+1
	if(((vphi.eq.0.0).or.(vphi.eq.180.0)).and.cango)then
c integrate over theta incident
	write(6,*)'vsource. vphi=0 or 180'
          do jprim=1,nlos
             ddomeg=df*dmu(jprim)
c integrate over delta phi incident
c if phi out is equal to zero use symetry about the solar plane for I1 and
c I2, and neg-symetry for I3 and I4.  Also have neg-symetry in Phase matrix
c for the upper right four elements and the lower left four elements.
c
c scattering from phi=0.0 direction
c create the multiple scattering matrix
             do n=1,np
                do m=1,np
                   pn(m,n)=wal*fmatrx(m,n,1,jprim,1)+
     &wrl*rmatrx(m,n,1,jprim,1)+
     &wcl*cmatrx(m,n,1,jprim,1)
                enddo
             enddo
             do n=1,np
                ep(n)=esi0(n,1,jprim,lprevious)
                ec(n)=esi0(n,1,jprim,lcurent)
             enddo
             do m=1,np
                f1=pn(m,1)*ep(1)
                f2=pn(m,1)*ec(1)
                do n=2,np
                   f1=f1+pn(m,n)*ep(n)
                   f2=f2+pn(m,n)*ec(n)
                enddo
                f=f1*cf1
                f=f+f2*cf2
                enew(m)=enew(m)+f*ddomeg
             enddo
c scattering from phi=180.0 direction
             do n=1,np
                do m=1,np
                   pn(m,n)=wal*fmatrx(m,n,nfi,jprim,1)+
     &wrl*rmatrx(m,n,nfi,jprim,1)+
     &wcl*cmatrx(m,n,nfi,jprim,1)
                enddo
             enddo
             do n=1,np
                ep(n)=esi0(n,nfi,jprim,lprevious)
                ec(n)=esi0(n,nfi,jprim,lcurent)
             enddo
             do m=1,np
                f1=pn(m,1)*ep(1)
                f2=pn(m,1)*ec(1)
                do n=2,np
                   f1=f1+pn(m,n)*ep(n)
                   f2=f2+pn(m,n)*ec(n)
                enddo
                f=f1*cf1
                f=f+f2*cf2
                enew(m)=enew(m)+f*ddomeg
             enddo
c integrate over delta phi incident
c if phi out is equal to zero use symetry about the solar plane for I1 and
c I2, and neg-symetry for I3 and I4.  Also have neg-symetry in Phase matrix
c for the upper right four elements and the lower left four elements.
             ddomeg=ddomeg*2.0d0
             do 40 k=2,nfi-1
                do n=1,np
                   pn(1,n)=wal*fmatrx(1,n,k,jprim,1)+
     &wrl*rmatrx(1,n,k,jprim,1)+
     &wcl*cmatrx(1,n,k,jprim,1)
                   pn(2,n)=wal*fmatrx(2,n,k,jprim,1)+
     &wrl*rmatrx(2,n,k,jprim,1)+
     &wcl*cmatrx(2,n,k,jprim,1)
                enddo
                if(vphi.eq.180.0)then
                  nn=nfip1-k
                else
                  nn=k
                  pn(1,3)=-pn(1,3)
                  pn(1,4)=-pn(1,4)
                  pn(2,3)=-pn(2,3)
                  pn(2,4)=-pn(2,4)
                end if
                do n=1,np
                   ep(n)=esi0(n,nn,jprim,lprevious)
                   ec(n)=esi0(n,nn,jprim,lcurent)
                enddo
c m=1
                f1=pn(1,1)*ep(1)
                f2=pn(1,1)*ec(1)
                do n=2,np
                   f1=f1+pn(1,n)*ep(n)
                   f2=f2+pn(1,n)*ec(n)
                enddo
                f=f1*cf1
                f=f+f2*cf2
                enew(1)=enew(1)+f*ddomeg
c m=2
                if(np.ge.2)then
                  f1=pn(2,1)*ep(1)
                  f2=pn(2,1)*ec(1)
                  do n=2,np
                     f1=f1+pn(2,n)*ep(n)
                     f2=f2+pn(2,n)*ec(n)
                  enddo
                  f=f1*cf1
                  f=f+f2*cf2
                  enew(2)=enew(2)+f*ddomeg
                endif
40           continue
          enddo 
	else
c output phi is NOT 0.0 or 180.0
c integrate over theta incident
          do 80 jprim=1,nlos
             ddomeg=df*dmu(jprim)
c integrate over delta phi incident for incident intensities in directions
c phi in = 0.0 to phi in = 180.0
             do k=1,nfi
                do n=1,np
                   do m=1,np
                      pn(m,n)=wal*fmatrx(m,n,k,jprim,1)+
     &wrl*rmatrx(m,n,k,jprim,1)+
     &wcl*cmatrx(m,n,k,jprim,1)
                   enddo
                enddo
                do n=1,np
                   ep(n)=esi0(n,k,jprim,lprevious)
                   ec(n)=esi0(n,k,jprim,lcurent)
                enddo
                do m=1,np
                   f1=pn(m,1)*ep(1)
                   f2=pn(m,1)*ec(1)
                   do n=2,np
                      f1=f1+pn(m,n)*ep(n)
                      f2=f2+pn(m,n)*ec(n)
                   enddo
                   f=f1*cf1
                   f=f+f2*cf2
                   enew(m)=enew(m)+f*ddomeg
                enddo
             enddo
c loop for phi in > pi, so must change sign of I3 and I4 matrix elements in each
c row of phase matrix, since they are odd functions of phi.
             do k=1,nfi-2
                do m=1,np
c n=1&2
                   pn(m,1)=wal*fmatrx(m,1,k,jprim,2)+
     &wrl*rmatrx(m,1,k,jprim,2)+
     &wcl*cmatrx(m,1,k,jprim,2)
                   pn(m,2)=wal*fmatrx(m,2,k,jprim,2)+
     &wrl*rmatrx(m,2,k,jprim,2)+
     &wcl*cmatrx(m,2,k,jprim,2)
c because of neg-symetery of I3 and I4 will multiply p(3) and p(4) by -1
c phi in > pi
                   do n=3,np
                      pn(m,n)=-wal*fmatrx(m,n,k,jprim,2)-
     &wrl*rmatrx(m,n,k,jprim,2)-
     &wcl*cmatrx(m,n,k,jprim,2)
                   enddo
                enddo
                nn=nfi-k
                do n=1,np
                   ep(n)=esi0(n,nn,jprim,lprevious)
                   ec(n)=esi0(n,nn,jprim,lcurent)
                enddo
                do m=1,np
                   f1=pn(m,1)*ep(1)
                   f2=pn(m,1)*ec(1)
                   do n=2,np
                      f1=f1+pn(m,n)*ep(n)
                      f2=f2+pn(m,n)*ec(n)
                   enddo
                   f=f1*cf1
                   f=f+f2*cf2
                   enew(m)=enew(m)+f*ddomeg
                enddo
             enddo
80        continue
        end if
      return
      end
c ---------------------------------------------------------------------
