c $Header: /usr/people/flittner/radtran/flatpsv/src/cfnp.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
C########################################################################
        subroutine cfnp(wavel,aerodist,phasefile,omega0,cext,g,ierr)

C---------------------------------------------------------------------
C compute the particlate size distribution and single scattering
C phase matrix using Mie theory.
c
c last modified 12-19-96...def
c purpose: add passage of scattering asymmetry parameter (g). Also add
C          error flag ierr
C
C last modified: July 21, 1997...def
C purpose: add non-spherical size dist. option (iflag=7), but must
C          run t2m program first to create the aerosol.phs files.
C last modified: June 16, 1998...def
c purpose: read the phase file from extended precision version of 
c          tmatrix code, tmq.
C
C last mod. Dec. 30, 1998...def
C purpose: for iflag=1, input the maximum radius of constant dn/dlogr
C
c
C---------------------------------------------------------------------
	implicit none
c integers that are passed
	integer iflag,n1,ierr
c real that are passed
        real*8 wavel,aerodist(22),omega0,cext,g
c characters that are passed
	character phasefile*100
c common
        logical levendx
        common /othrswch/levendx
        save /othrswch/
c integers that are parameters
	integer n
        parameter (n=5000)
c integers that are local
	integer nmode,i
        real*8 f(n+1,3),r(n+1),anu,sigma(3),rmean(3),Nc(3)
        real*8 radmin(3),radmax(3),refre(3),refim(3)
        real*8 refmed,cscat,a,b,alpha,gamma
        character buff*80
        logical exist
c
c aerodist array contains the information concerning the size dist.
c
c aerodist(1)=iflag
c aerodist(2)=refre(1)
c aerodist(3)=refim(1)
c aerodist(4)=radmin
c aerodist(5)=radmax
c if(iflag.eq.1)then
c   aerodist(6)=anu
c else if(iflag.eq.2)then
c   aerodist(6)=sigma
c   aerodist(7)=rmean
c else if(iflag.eq.3)then
c   aerodist(6)=a
c   aerodist(7)=b
c   aerodist(8)=alpha
c   aerodist(9)=gamma
c else if(iflag.eq.4)then
c   aerodist(4)=radmin1
c   aerodist(5)=radmax1
c   aerodist(6)=sigma1
c   aerodist(7)=rmean1
c   aerodist(8)=Nc1
c   aerodist(9)=radmin2
c   aerodist(10)=radmax2
c   aerodist(11)=sigma2
c   aerodist(12)=rmean2
c   aerodist(13)=Nc2
c endif
c
c the size dist. type
        iflag=nint(aerodist(1))
c the real and imaginary index of refraction for the particulate
c and the index of refraction of the background medium.
        refre(1)=aerodist(2)
        refim(1)=aerodist(3)
        refmed=1.0d0
c the min and max radii
	radmin(1)=aerodist(4)
        radmax(1)=aerodist(5)
c the parameters for the size type
        if(iflag.eq.1)then
c power law distribution
          anu=aerodist(6)
          rmean(1)=aerodist(7)
        else if(iflag.eq.3)then
c modified gamma
          a=aerodist(6)
          b=aerodist(7)
          alpha=aerodist(8)
          gamma=aerodist(9)
        else if(iflag.eq.2.or.iflag.eq.4.or.iflag.eq.5)then
c log-normal distribution
          sigma(1)=aerodist(6)
          rmean(1)=aerodist(7)
          sigma(1)=log(sigma(1))
          if(iflag.eq.4.or.iflag.eq.5)then
c bimodal log-normal dist
            Nc(1)=aerodist(8)
            radmin(2)=aerodist(9)
            radmax(2)=aerodist(10)
            sigma(2)=aerodist(11)
            sigma(2)=log(sigma(2))
            rmean(2)=aerodist(12)
            Nc(2)=aerodist(13)
c the real and imaginary index of refraction for the particulate
c and the index of refraction of the background medium.
            refre(2)=aerodist(19)
            refim(2)=aerodist(20)
            if(iflag.eq.5)then
c trimodal log-normal dist
              radmin(3)=aerodist(14)
              radmax(3)=aerodist(15)
              sigma(3)=aerodist(16)
              sigma(3)=log(sigma(3))
              rmean(3)=aerodist(17)
              Nc(3)=aerodist(18)
c the real and imaginary index of refraction for the particulate
c and the index of refraction of the background medium.
              refre(3)=aerodist(21)
              refim(3)=aerodist(22)
            endif
          endif
        else if(iflag.eq.7)then
c non-spherical particles will just read the contents of the aerosol.phs file
          write(6,*)'cfnp. looking for ',phasefile
          inquire(file=phasefile,exist=exist)
          if(exist)then
	    open(18,file=phasefile,status='old')
            write(6,*)'cfnp. openning ',phasefile
            do i=1,10
               read(18,'(a)')buff
            enddo
            read(18,'(5x,e12.6,7x,e12.6,6x,e12.6,8x,e12.6)')cext,cscat,
     &omega0,g
c convert cross-sections from um^2 to cm^2
            cext=cext*1.0e-08
            cscat=cscat*1.0e-08
c            write(6,'(6x,e12.6,7x,e12.6,6x,e12.6,8x,e12.6)')cext,cscat,
c     &omega0,g
            goto 999
          else
            write(6,*)'cfnp. Must create the aerosol.phs file for ',
     &'non-spherical particles using t2m.x'
            write(6,*)'cfnp. Will stop now'
            ierr=1
            goto 999
          endif
          continue
        else
          write(6,*)'cfnp. Error!! Size distribution type flag ',
     &'(iflag) must be 1-5 !!!'
          write(6,*)'cfnp. Will stop now'
          ierr=1
          goto 999
        endif
        inquire(file=phasefile,exist=exist)
        if(exist)then
	  open(18,file=phasefile,status='old')
c skip the header
          buff(1:24)="                        "
          do while(buff(1:24).ne."SINGLE SCATTERING ALBEDO")
             read(18,'(a)')buff
          enddo
          read(18,'(a)')buff
	  read(18,*)cext,cscat
          read(18,*)g
          omega0=cscat/cext
          if(omega0.gt.1.0d0) omega0=1.0d0
	else
c call size distribution
	  call fdist(f,r,wavel,n1,n,iflag,radmin,radmax,anu,sigma,rmean,
     &Nc,a,b,alpha,gamma,refmed,nmode,levendx)
c open aerosol phasefile
	  open(18,file=phasefile,status='unknown')
c put in the the size dist. info. header
	  if(iflag.eq.1) then
            write(18,1010)iflag,anu
	  else if(iflag.eq.2)then
            write(18,1020)iflag,exp(sigma(1)),rmean(1)
	  else if(iflag.eq.3)then
            write(18,1030)iflag,a,b,alpha,gamma
	  else if(iflag.eq.4)then
            write(18,1060)iflag,exp(sigma(1)),rmean(1),
     &exp(sigma(2)),rmean(2)
	  else if(iflag.eq.5)then
            write(18,1070)iflag,exp(sigma(1)),rmean(1),
     &exp(sigma(2)),rmean(2),exp(sigma(3)),rmean(3)
	  end if
	  write(18,1040)r(1),r(n1+1)
c something about the dx spacing (even or graduated)
	  if(levendx)then
            write(18,1041)6.283185d0*(r(3)-r(2))/(wavel/refmed)
          else
            write(18,1042)
          endif
	  write(18,1050)wavel,refre(1),refim(1)
          if(iflag.gt.3)then
	    write(18,1080)refre(2),refim(2)
            if(iflag.gt.4) write(18,1090)refre(3),refim(3)
          endif
c call phase matrix computation routine which will write to file 18.
	  call phasf(f,r,n1,wavel,omega0,n,refre,refim,refmed,cext,
     &nmode,g)
	endif
999     close(18)
        return
1010    format('IFLAG = ',i3,'; POWER LAW DIST. (JUNGE);',/,
     &'DN/DLOG(R)=R**(-ANU)',/,'ANU = ',f6.4)
1020    format('IFLAG = ',i3,'; LOG NORMAL DIST.;',/,
     &'DN/DLOG(R)=1/SQRT(2*PI*LN(SIGMA)^2)*EXP(-0.5*(LN(R/Rmean)/',
     &'LN(SIGMA))^2)',/,'SIGMA =',1PE11.4,' ; Rmean =',1PE11.4,' (um)')
1030    format('IFLAG = ',i3,'; MODIFIED GAMMA DIST.;',/,
     &'DN/DLOG(R)=A*R^(ALPHA+1)*EXP(-B*R^GAMMA)',/,
     &'A =',1PE11.4,'; B =',1PE11.4,'; ALPHA =',1PE11.4,
     &'; GAMMA =',1PE11.4)
1040    format('THE MINIMUM RADIUS = ',1PE11.4,' (um) AND ',
     &         'THE MAXIMUM RADIUS = ',1PE11.4,' (um)')
1041    format('THE SIZE PARAMETER SPACING IS EVEN WITH DX =',
     &F6.4)
1042    format('THE SIZE PARAMETER SPACING IS DX =',
     &'0.01,0.1,0.2,0.5,1.0 @ X<=10,20,30,100')
1050    format('WAVELENGTH = ',1PE11.4,' (um)',/
     &'REAL INDEX OF REFRACTION = ',1PE11.4,/,
     &'IMAGINARY INDEX OF REFRACTION = ',1PE11.4)
1060    format("IFLAG = ",i3,"; Bi-Modal LOG NORMAL DIST.;",/,
     &"DN/DLOG(R)=Nc1/SQRT(2*PI*LN(SIGMA1)^2)*EXP(-0.5*(LN(R/Rmean1)/",
     &"LN(SIGMA1))^2)",/,
     &"          +Nc2/SQRT(2*PI*LN(SIGMA2)^2)*EXP(-0.5*(LN(R/Rmean2)/",
     &"LN(SIGMA1))^2)",/,
     &  "SIGMA1 =",1PE11.4," ; Rmean1 =",1PE11.4," (um)",
     &/,"SIGMA2 =",1PE11.4," ; Rmean2 =",1PE11.4," (um)")
1070    format("IFLAG = ",i3,"; Tri-Modal LOG NORMAL DIST.;",/,
     &"DN/DLOG(R)=Nc1/SQRT(2*PI*LN(SIGMA1)^2)*EXP(-0.5*(LN(R/Rmean1)/",
     &"LN(SIGMA1))^2)",/,
     &"          +Nc2/SQRT(2*PI*LN(SIGMA2)^2)*EXP(-0.5*(LN(R/Rmean2)/",
     &"LN(SIGMA2))^2)",/,
     &"          +Nc3/SQRT(2*PI*LN(SIGMA3)^2)*EXP(-0.5*(LN(R/Rmean3)/",
     &"LN(SIGMA3))^2)",/,
     &  "SIGMA1 =",1PE11.4," ; Rmean1 =",1PE11.4," (um)",
     &/,"SIGMA2 =",1PE11.4," ; Rmean2 =",1PE11.4," (um)",
     &/,"SIGMA3 =",1PE11.4," ; Rmean3 =",1PE11.4," (um)")
1080    format(
     &'REAL INDEX OF REFRACTION for mode2 = ',1PE11.4,/,
     &'IMAGINARY INDEX OF REFRACTION for mode2 = ',1PE11.4)
1090    format(
     &'REAL INDEX OF REFRACTION for mode3 = ',1PE11.4,/,
     &'IMAGINARY INDEX OF REFRACTION for mode3 = ',1PE11.4)
        end
