c $Header: /usr/people/flittner/radtran/flatpsv/src/disort2gs.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
	subroutine disort2gs(zmod,presmod,ttf,ttr,tto3,tth2o,
     &dtaumax,nz,tf,tray,th2o,to3,ierr,ttc,tc)
c
c convert disort atmosphere into gs atmosphere
c
       implicit none
       include 'consts.cmn'
       include 'param.inc'
       include 'catmdata.cmn'
       include 'cstdatm.cmn'
c passed in as input
c passed out as output
       integer nz,ierr
c real varialbes that are passed
       real*8 zmod(maxnz),tf(maxnz-1),tray(maxnz-1),to3(maxnz-1)
       real*8 th2o(maxnz-1),presmod(maxnz-1),ttf,ttr,tto3,tth2o
       real*8 dtaumax,ttc,tc(maxnz-1)
c local
        integer nloc,i,j,igs,ngs,ndisort,iunt,nlgs,ipwr
        parameter (nloc=22)
	integer indx(nloc)
        real*8 trayloc(nloc),tfloc(nloc),to3loc(nloc)
        real*8 tcloc(nloc),th2oloc(nloc),dta,dts,dtray,dtaer,dtcld
        real*8 prc(nloc),htc(nloc),t(nloc),dt(nloc),tba(nloc)
        real*8 tbc(nloc),om(nloc)
        real*8 dtau,z0,factor,Hray
	character fname*80,buf*80
c
	ipwr=0
c
c read the disort atmosphere
c
	fname='disort.prf'
	iunt=18
	open(iunt,file=fname,status='old')
	do i=1,5
           read(iunt,'(a)')buf
        enddo
	ndisort=22
	ttf=0.0d0
	ttr=0.0d0
	tto3=0.0d0
	tth2o=0.0d0
	ttc=0.0d0
        do i=1,ndisort
           read(iunt,*)indx(i),prc(i),htc(i),t(i),dt(i),tba(i),
     &tbc(i),om(i)
           dta=dt(i)*(1.0d0-om(i))
           if(dta.lt.0.0d0)dta=0.0d0
           dts=dt(i)*om(i)
           if(dts.lt.0.0d0)dts=0.0d0
           dtcld=dts*tbc(i)
           if(dtcld.lt.0.0d0)dtcld=0.0d0
           dtaer=dts*tba(i)
           if(dtaer.lt.0.0d0)dtaer=0.0d0
           dtray=dt(i)-dta-dtcld-dtaer
           if(dtray.lt.0.0d0)dtray=0.0d0
c check to see if need to zero-out cloud depending upon the
c state of the logical variable
           if(cloud.eqv..FALSE.)then
             tbc(i)=0.0d0
             dt(i)=dt(i)-dtcld
             dtcld=0.0d0
           endif
c get the totals
           tto3=tto3+dta
           ttr=ttr+dtray
	   ttc=ttc+dtcld
	   ttf=ttf+dtaer
c make total array for each component
           trayloc(i)=ttr
           to3loc(i)=tto3
           tcloc(i)=ttc
           tfloc(i)=ttf
           th2oloc(i)=tth2o
	enddo
        close(iunt)
        write(6,'(a15,f9.6)')'disort2gs. ttr',ttr
        write(6,'(a15,f9.6)')'disort2gs. tto3',tto3
        write(6,'(a15,f9.6)')'disort2gs. ttc',ttc
        write(6,'(a15,f9.6)')'disort2gs. ttf',ttf
c
c now layer by layer divide the disort layer into gs size layers
c When have a cloud, go ahead and divide into equal delta tau layers
c
        igs=0
        do i=1,ndisort
           dta=dt(i)*(1.0d0-om(i))
           if(dta.lt.0.0d0)dta=0.0d0
           dts=dt(i)*om(i)
           if(dts.lt.0.0d0)dts=0.0d0
           dtcld=dts*tbc(i)
           if(dtcld.lt.0.0d0)dtcld=0.0d0
           dtaer=dts*tba(i)
           if(dtaer.lt.0.0d0)dtaer=0.0d0
           dtray=dt(i)-dta-dtcld-dtaer
           if(dtray.lt.0.0d0)dtray=0.0d0
           if(i.eq.1)then
             Hp=-(htc(2)-htc(1))/log(prc(2)/prc(1))
             Hray=Hp
             z0=htc(1)
             Ho3=Hp
             Hf=Hp
             Hh2o=Hp
           else
             Hp=-(htc(i)-htc(i-1))/log(prc(i)/prc(i-1))
             Hray=Hp
c             Hray=-(htc(i)-htc(i-1))/log((trayloc(i))/trayloc(i-1))
             z0=htc(i-1)
           endif
c # of gs layers in this disort layer
           if(tbc(i).gt.0.0d0)then
             if(tcloc(i).lt.ttc*0.5d0)then
               ipwr=ipwr+1
             else
               ipwr=ipwr-1
             endif
             if(ipwr.le.0)ipwr=1
             nlgs=dtcld/(dtaumax*ipwr)
           else
             nlgs=dts/dtaumax
           endif
           if(nlgs.eq.0)nlgs=1
           dtau=dts/dble(nlgs)
           factor=1.0d0/dble(nlgs)
	write(6,*)'disort2gs. i nlgs dtau',i,nlgs,dtau
           do j=1,nlgs
              igs=igs+1
              if(igs.gt.maxnz-1)then
                write(6,*)'disort2gs. too many layers'
	        write(6,*)'disort2gs. must increace dtaumax'
                ierr=1
                goto 200
              endif
c now get the height scale to correspond to the new gs layers
c by using exponential interpolation of the disort pressure layers
              if(i.eq.1)then
                zmod(igs)=z0-Hray*log(dble(j)/dble(nlgs))
              else
                zmod(igs)=z0-Hray*
     &log((trayloc(i-1)+dtray*factor*dble(j))/trayloc(i-1))
              endif
              presmod(igs)=prc(i-1)*exp(-(zmod(igs)-z0)/Hp)
c use exponential for the top layer
              if(i.eq.1)then
                if(igs.eq.1)then
                  factor=exp(-(zmod(igs)-htc(1))/Hp)
                else
                  factor=exp(-(zmod(igs)-htc(1))/Hp)-
     &exp(-(zmod(igs-1)-htc(1))/Hp)
                endif
              endif
              tf(igs)=dtaer*factor
	      tray(igs)=dtray*factor
	      th2o(igs)=0.0d0
	      to3(igs)=dta*factor
	      tc(igs)=dtcld*factor
           enddo
        enddo
	ngs=igs
        zmod(ngs)=htc(ndisort)
        presmod(ngs)=prc(ndisort)
c
c create the std atmosphere arrays for cmppa (compuation of the solar
c attenuation.
c
c rayleigh
	write(6,*)'disort2gs. nstd',nstd
	do i=1,nstd
c find the index in model atmosphere of the 2 points straddling the
c point zstd(i)
           if(zstd(i).ge.htc(1))then
             Hp=-(htc(1)-htc(2))/log(prc(1)/prc(2))
             factor=exp(-(zstd(i)-htc(1))/Hp)
             tauray(i)=trayloc(1)*factor
             tauf(i)=tfloc(1)*factor
             tauh2o(i)=0.0d0
             tauo3(i)=to3loc(1)*factor
             tauc(i)=tcloc(1)*factor
           else
             j=2
             do while(zstd(i).lt.htc(j))
                j=j+1
             enddo
             factor=(zstd(i)-htc(j))/(htc(j-1)-htc(j))
             tauray(i)=trayloc(j-1)*factor+trayloc(j)*(1.0d0-factor)
             tauf(i)=tfloc(j-1)*factor+tfloc(j)*(1.0d0-factor)
             tauh2o(i)=0.0d0
             tauo3(i)=to3loc(j-1)*factor+to3loc(j)*(1.0d0-factor)
             tauc(i)=tcloc(j-1)*factor+tcloc(j)*(1.0d0-factor)
           endif
           ttotal(i)=tauray(i)+tauf(i)+tauh2o(i)+tauo3(i)+tauc(i)
        enddo
        nz=ngs
200     return
        end
C-----------------------------------------------------------------------
