c $Header: /usr/people/flittner/radtran/flatpsv/src/integoz.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
       subroutine integoz(zoz,oz,temp,noz,o3coe,tto3,sumo3,Ho3)
c must integrate over distribution to get ozone optical depth.
c Ozone is input in terms of number density [#/cubic cm]
c absorption coef. is in terms of [1/atm-cm].
c optical depth = oz [#/cc] * dz [km] * 1.0e5 [cm/km] * 
c                 coeff [1/atm-cm] / Nl [1/(#/atm-cm)]
c Nl=Locshmidt's number = 2.6867e19 #/cm^2
c
c last mod. on 10/07/97...def
c purpose: check for Ho3 lt 0.0
c

	 implicit none
         include 'consts.cmn'
c
	 integer noz
         real*8 zoz(noz),oz(noz),temp(noz),o3coe(3),tto3,sumo3,Ho3
c local
         integer j,is,ie,ic
         real*8 delz,ozavg,tempavg,coeff,doz
c
         if(zoz(1).lt.zoz(noz))then
           is=2
           ie=noz
           ic=1
         else
           is=noz-1
           ie=1
           ic=-1
         endif
         tto3=0.0d0
         sumo3=0.0d0
         do 10 j=is,ie,ic
            delz=abs(zoz(j)-zoz(j-ic))*1.0d05
            ozavg=0.5d0*(oz(j)+oz(j-ic))/Nl
            tempavg=0.5d0*(temp(j)+temp(j-ic))-273.0d0
            coeff=(o3coe(1)+o3coe(2)*tempavg+o3coe(3)*tempavg*tempavg)
            doz=ozavg*delz
            sumo3=sumo3+doz
            tto3=tto3+doz*coeff
10       continue
         if(oz(ie).ne.oz(ie-ic))then
c scale height for alt. above zoz(numz)
           Ho3=(zoz(ie)-zoz(ie-ic))/log(oz(ie-ic)/oz(ie))
           if(Ho3.lt.0.0)Ho3=0.0d0
         else
           Ho3=0.0d0
         endif
c         write(6,'(a12,1pE13.4)')'divide. Ho3=',Ho3
         doz=Ho3*oz(ie)*1.0d05/Nl
         sumo3=sumo3+doz
         tempavg=temp(ie)-273.0d0
         coeff=(o3coe(1)+o3coe(2)*tempavg+o3coe(3)*tempavg*tempavg)
         tto3=tto3+doz*coeff
c         write(6,'(a51,1pe13.4,a7)')
c     &'divide. the total o3 for the input distribution is ',sumo3,
c     &' atm-cm'
	return
        end
