c $Header: /usr/people/flittner/radtran/flatpsv/src/interpms.f,v 1.14 1999/08/16 18:59:07 flittner Exp flittner $
C----------------------------------------------------------------------
        subroutine interpms(nlos,nz,np,esi0,esing0,thd,ndownlos,
     &vtheta,vphi,ivlev,voutms)
c
c Interpolate multiple scatter using cubic interpolation in theta and phi.
c
c The theta interpolation is done in each full plane (0-180, 30-150,
c 60-120, 90-90) by adding nex values below 0 and nex2 values above 180.
c
c For the phi interpolation, the data values are taken from the interpolated
c theta value at each grided phi plane.  For Stokes parameters 1&2 
c even symmetry about the 0-180 plane is used and for parameters 3&4
c odd symmetry is used.
c
	implicit none
        include 'consts.cmn'
        include 'param.inc'
c constants passed from the calling program
	integer nlos,nz,np,ndownlos,ivlev
c values calculated before hand that will be used in calculations
	real*8 esi0(4,nfi,mlos,maxnz),thd(mlos),vtheta,vphi
	real*8 esing0(4,nfi,mlos,maxnz),voutms(4)
c local
        integer nex,nex2,mex,mex2,mode
        parameter (mex=2,mex2=2)
        integer j,i,m,ie,is,ny,nyaz,iphi
        real*8 xaz(2*nfi-1),yaz(2*nfi-1),y(mlos+mex+mex2)
        real*8 yp2(mlos+mex+mex2)
        real*8 delphi,yp1,ypn,x(mlos+mex+mex2),xv,x0
c
c
        delphi=180.0d0/dble(nfi-1)
        do j=1,nfi
           xaz(j)=dble(j-1)*delphi
        enddo
        do j=nfi+1,2*nfi-1
           xaz(j)=dble(j-1)*delphi
        enddo
        nyaz=2*nfi-1
c will use "natrual" spline
        yp1=1.0d30
        ypn=1.0d30
        mode=0
c
c for the level, get the data points along each phi plane
c
        if(vtheta.lt.90.0d0)then
          is=1
          ie=ndownlos
          nex=2
          nex2=0
          ny=ndownlos+nex+nex2
          x0=0.0d0
        else
          is=ndownlos+1
          ie=nlos
          nex=0
          nex2=2
          ny=(nlos-ndownlos)+nex+nex2
          x0=180.0d0
        endif
        xv=vtheta
c
        do i=is,ie
           x(nex+1+i-is)=thd(i)
        enddo
        do i=1,nex
           x(nex+1-i)=x0-x(nex+i)
        enddo
        do i=1,nex2
           x(ny-nex2+i)=360.0d0-x(ny-nex2+1-i)
        enddo
c
        do m=1,np
           do j=1,nfi
              do i=is,ie
                 y(nex+1+i-is)=esi0(m,j,i,ivlev)-esing0(m,j,i,ivlev)
              enddo
              iphi=nfi-j+1
              do i=1,nex
                 y(nex+1-i)=esi0(m,iphi,is+i-1,ivlev)-
     &esing0(m,iphi,is+i-1,ivlev)
                 if(m.ge.3)y(nex+1-i)=-y(nex+1-i)
              enddo
              do i=1,nex2
                 y(ny-nex2+i)=esi0(m,iphi,ie-i+1,ivlev)-
     &esing0(m,iphi,ie-i+1,ivlev)
                 if(m.ge.3)y(ny-nex2+i)=-y(ny-nex2+i)
              enddo
              call spline(x,y,ny,yp1,ypn,yp2,mode)
              call splint(x,y,yp2,ny,xv,yaz(j),mode)
           enddo
           if(m.lt.3)then
             do j=nfi+1,2*nfi-1
                yaz(j)=yaz(nfi-(j-nfi))
             enddo
           else
             do j=nfi+1,2*nfi-1
                yaz(j)=-yaz(nfi-(j-nfi))
             enddo
           endif
c now interpolate in azimuth
           call spline(xaz,yaz,nyaz,yp1,ypn,yp2,mode)
           call splint(xaz,yaz,yp2,nyaz,vphi,voutms(m),mode)
        enddo
        return
        end
