c $Header: /usr/people/flittner/radtran/flatpsv/src/main.f,v 1.14 1999/08/16 19:07:32 flittner Exp flittner $
	program main
c main driver for the combined herman code
C
C last modified: Nov. 22, 1996...def
C purpose: read in the cloud od if use waveloop
c
c last modified: May 7, 1997...def
c purpose: pass the boundaries of the theta and phi arrays
C
c last modified: May 28, 1997...def
c purpose: improve the wavelength looping by reading index of refraction also.
c          Also create the basename in main instead of flatpsv.
c
c last modified: May 30, 1997...def
c purpose: Check for size dist = 0 and optical depth > 0.
c
c last mod.: July 15, 1999...def
c purpose: read atmosphere files created by modtran.
c
C-----------------------------------------------------------------
C
	implicit none
c constants
        include 'consts.cmn'
c variables that are parameter statements
        include 'param.inc'
c atmstr stuff read by read51
        integer iatmtype,ndl
        logical lgcorrect,daveps,lchkdz,lthkcld
        real*8 ttc,ttf,ttr,totwat,totoz,wavel,sfcprs,Fk
	real*8 o3coe(3),top,dtaumax,h2ocoe
        real*8 aerodist(22),clddist(22),pcldtop,pcldbot,aerz0,aersig
        real*8 deltaoz
        integer ierr
c file names for profiles
        character*100 prsfname,aerfname,o3fname,h2ofname,tmpfname
        common /cprofname/prsfname,aerfname,o3fname,h2ofname,tmpfname
        save /cprofname/
c settheta stuff
        integer iangtyp
c flat stuff read by read51
        integer npass,isfc,np,ipseudo,nsun,isfc0
        real*8 suns(12),Fo,vthmintop,vthmaxtop,dvthtop,vphimintop
        real*8 vphimaxtop,dvphitop,refl
        real*8 vthminbot,vthmaxbot,dvthbot,vphiminbot,vphimaxbot
        real*8 dvphibot
        logical lprttop,lprtbot,doforward,lprtflx,linterpms,luseigeo
        logical laureole,lwaveloop
        real*8 thetapmin,thetapmax,dthetap
c integers that are passed
	integer nz,nlos
c real variables that are passed
        real*8 zit(maxnz),tf(maxnz-1),tray(maxnz-1),tto3,tth2o,sun
        real*8 th2o(maxnz-1),to3(maxnz-1),tabs(maxnz-1),tc(maxnz-1)
        real*8 theta(mlos),gamma,pres(maxnz-1),thdbnd(mlos+1)
        real*8 phibnd(nfi+1)
c characters that are passed
        character aphasefile*100,cphasefile*100,basename*13
c printed values
        integer mvth,mvphi,nvthtop,nvthbot,nvphitop,nvphibot
        parameter (mvth=46,mvphi=7)
        real*8 vthetas(mvth,2),vphis(mvphi,2)
        real*8 I0(4,mvth,mvphi,2),T(4,mvth,2),Sbar,Tbar
c local
        integer i,j
        character fname*100,tbuf*1
c default values for file names
c the profiles are done in the block data routine bdprofname.f
        data aphasefile/'aerosol.phs'/
        data cphasefile/'cloud.phs'/
c others
        data linterpms/.TRUE./
        data luseigeo/.TRUE./
        data lwaveloop/.FALSE./
        data laureole/.FALSE./
        data thetapmin,thetapmax,dthetap/0.25d0,7.0d0,0.25d0/
        data lthkcld/.TRUE./
c set number of theta angles to 28
	data iangtyp/5/
c
c*****************************************************************
c Files used:
c Unit        I/O                 Name/purpose
c 12           O               phasf.out
c 14           O               pa.out
c 16           I               constituent profile
c 16           I               proname.dat
c 18          O/I              Mie Scattering Phase Function
c 31           O               atmstr.out
c 42           O               estimated down flux
c 43           O               estimated up flux
c 51           I               flat.in, addswitchs
c 52           I               coes (loop for wavelengths)
c 53           I               index of refraction (aerosol/clouds)
c 61           O               flat.out
c 62           O               flat.top, flat.bot
c 63           O               flat.flx
c 64           O               flat.aur
c 71          I/O              geometric series index(iend-2) (scratch)
c 72          I/O              geometric series index(iend-1) (scratch)
c 73          I/O              geometric series index(iend)   (scratch)
c 81           O               miecalc.dat
c 92           O               standard and model profiles
c
c*****************************************************************
c
c
c define constants used
        call definec
c 
c read the input file
c
	call read51(ttf,ttr,totoz,totwat,wavel,ttc,sfcprs,Fk,
     &o3coe,top,dtaumax,h2ocoe,aerodist,clddist,pcldtop,pcldbot,
     &daveps,ndl,
     &iangtyp,npass,isfc0,np,ipseudo,nsun,
     &refl,suns,Fo,vthmintop,vthmaxtop,dvthtop,vphimintop,
     &vphimaxtop,dvphitop,
     &vthminbot,vthmaxbot,dvthbot,vphiminbot,vphimaxbot,
     &dvphibot,
     &lprttop,lprtbot,doforward,lprtflx,
     &iatmtype,lgcorrect,linterpms,luseigeo,lchkdz,aerz0,aersig,
     &laureole,thetapmin,thetapmax,dthetap,deltaoz,ierr,lthkcld,
     &lwaveloop)
        if(ierr.ne.0)then
          write(6,*)'main. error in read51. Will stop now'
          goto 900
        endif
c
c set the theta angles
        call settheta(iangtyp,nlos,theta,ierr,thdbnd,phibnd)
        if(ierr.ne.0)then
          write(6,*)'main. error in settheta. Will stop now'
          goto 900
        endif
c
c compute and load the view angles
        if(lprttop)then
          nvthtop=nint((vthmaxtop-vthmintop)/dvthtop)+1
          do i=1,nvthtop
             vthetas(i,1)=180.0d0-(vthmintop+dble(i-1)*dvthtop)
          enddo
          if(iangtyp.eq.6)then
            do i=1,nvthtop
               vthetas(i,1)=acos(-(vthmintop+dble(i-1)*dvthtop))/dr
            enddo
          endif
          nvphitop=nint((vphimaxtop-vphimintop)/dvphitop)+1
          do i=1,nvphitop
             vphis(i,1)=vphimintop+dble(i-1)*dvphitop
          enddo
        endif
        if(lprtbot)then
          nvthbot=nint((vthmaxbot-vthminbot)/dvthbot)+1
          do i=1,nvthbot
             vthetas(i,2)=vthminbot+dble(i-1)*dvthbot
          enddo
          if(iangtyp.eq.6)then
            do i=1,nvthbot
               vthetas(i,2)=acos((vthminbot+dble(i-1)*dvthbot))/dr
            enddo
          endif
          nvphibot=nint((vphimaxbot-vphiminbot)/dvphibot)+1
          do i=1,nvphibot
             vphis(i,2)=vphiminbot+dble(i-1)*dvphibot
          enddo
        endif
        if(iatmtype.eq.6)lwaveloop=.TRUE.
        if(lwaveloop)then
          if(iatmtype.ne.6)then
c open the coes file and skip header
            open(52,file='coes',status='old',err=9010)
            read(52,'(a)')tbuf
            read(52,'(a)')tbuf
            read(52,'(a)')tbuf
          else if(iatmtype.eq.6)then
            open(unit=16,file='def.dat',status='old')
          endif
        endif
10      if(lwaveloop)then
          if(iatmtype.ne.6)then
            call r1linecoes(wavel,ttr,Fk,o3coe,h2ocoe,Fo,ttf,ttc,
     &aerodist,clddist,refl)
          else if(iatmtype.eq.6)then
c now read the wavelength and Fo
            read(16,'(5x,f11.3,6x,e13.7)',end=11)wavel,Fo
            goto 12
11          wavel=-999.
12          wavel=1.0e04/wavel
c            Fk=(6.0d0+3.0d0*0.0279)/(6.0d0-7.0d0*0.0279)
          endif
          if(wavel.lt.0.0)goto 900
        endif
        call chkodndist(aerodist(1),ttf)
        call chkodndist(clddist(1),ttc)
        if(lwaveloop)then
          if(ttf.gt.0.0)then
            if(wavel.lt.1.0)then
              write(aphasefile(1:19),'(a10,f5.4,a4)')"aerosol.w0",
     &wavel,".phs"
            else if(wavel.lt.10.0)then
              write(aphasefile(1:19),'(a9,f6.4,a4)')"aerosol.w",
     &wavel,".phs"
            else
              write(aphasefile(1:19),'(a9,e6.1,a4)')"aerosol.w",
     &wavel,".phs"
            endif
          endif
          if(ttc.gt.0.0)then
            if(wavel.lt.1.0)then
              write(cphasefile(1:17),'(a8,f5.4,a4)')"cloud.w0",
     &wavel,".phs"
            else if(wavel.lt.10.0)then
              write(cphasefile(1:17),'(a7,f6.4,a4)')"cloud.w",
     &wavel,".phs"
            else
              write(cphasefile(1:17),'(a7,e6.1,a4)')"cloud.w",
     &wavel,".phs"
            endif
          endif
        endif
c
c compute the depolarization ratio
          gamma=3.0d0*(Fk-1.0d0)/(4.0d0*Fk+6.0d0)
c
c divide the atmosphere
          write(6,1000)wavel
	  call atmstr(nz,ttf,ttr,tto3,tth2o,totoz,totwat,
     &wavel,tf,tray,to3,th2o,zit,pres,aphasefile,ttc,cphasefile,tc,
     &sfcprs,Fk,o3coe,h2ocoe,top,dtaumax,aerodist,clddist,pcldtop,
     &pcldbot,iatmtype,lgcorrect,daveps,ndl,ierr,lchkdz,aerz0,aersig,
     &deltaoz,lthkcld)
          if(ierr.ne.0)then
            write(6,*)'main. error in atmstr. Will stop now'
            goto 900
          endif
c
          if(npass.lt.0)then
            write(6,2000)
          else
c
c only pass the absorption layer values
c
            do i=1,nz-1
               tabs(i)=to3(i)+th2o(i)
            enddo
c
            do i=1,nsun
               sun=suns(i)
               if(isfc0.eq.4)then
c
c check the sun for isfc=4 (mirror) and set the sun to closest
c grid angle
c
                 call chksunmirror(sun,theta,nlos)
               endif
               write(6,2010)sun
c don't need to do lambertain surface for solar zenith angle # > 1
               if((i.gt.1).and.(isfc0.eq.0))then
                 isfc=-1
               else
                 isfc=isfc0
               endif
               call mbasename(lwaveloop,wavel,sun,basename)
               call flatpsv(nz,nlos,ttf,ttr,tto3,tth2o,wavel,
     &theta,zit,pres,tf,tray,tabs,aphasefile,ttc,tc,cphasefile,
     &npass,isfc,np,ipseudo,refl,gamma,sun,Fo,
     &lprttop,vthetas,vphis,nvthtop,nvphitop,I0,T,Sbar,Tbar,
     &lprtbot,nvthbot,nvphibot,mvth,mvphi,
     &doforward,lprtflx,linterpms,luseigeo,
     &laureole,thetapmin,thetapmax,dthetap,basename,ierr,
     &thdbnd,phibnd)
            if(ierr.ne.0)then
              write(6,*)'main. error in flatpsv. Will stop now'
              goto 900
            endif
            enddo
          endif
          if(lwaveloop)goto 10
900     continue
        if(lwaveloop)then
          close(50)
          if(iatmtype.eq.6)close(16)
        endif
        goto 9999
1000    format(1x,'main. Will now construct the model atmosphere and ',
     &'calculate the necessary',/,7x,'phase function files for ',
     &'wavelength=',f8.4,' (u).')
2000    format(1x,'main. Will NOT run the radiative transfer code ',
     &'since the # of iterations < 0')
2010    format(1x,'main. Will now run the radiative transfer code ',
     &'for solar zenith angle ',f6.2)
9010    write(6,*)'main. error opening coes file for looping of ',
     &'wavelengths.  Will stop now.'
9999    end
C-------------------------------------------------------------------------
c
       subroutine chksunmirror(sun,theta,nlos)
c
c check the sun for isfc=4 (mirror) and set the sun to closest
c grid angle
c
       implicit none
       integer nlos
       real*8 sun,theta(nlos)
c
       integer i,j
       real*8 d
c
       j=nlos
       d=abs(sun-180.0d0+theta(j))
       i=j-1
       do while (abs(sun-180.0d0+theta(i)).lt.d)
          j=i
          d=abs(sun-180.0d0+theta(j))
          i=i-1
       enddo
       if(d.gt.0.1)then
         write(6,*)'chksunmirror. Must reset sun to closest grid',
     &' angle for mirror surface.'
         write(6,'(a26,f6.2,a4,f6.2)')'chksunmirror. Reset from ',
     &sun,' to ',180.0d0-theta(j)
         sun=180.0d0-theta(j)
       endif
       return
       end
c
c
       subroutine getrefind(w,f,dist)
c
c get the refractive index (real,imag) for the particulate size distribution 
c from the file f.  One index of refraction is needed for each mode of the 
c size distribution.
c
       implicit none
c passed
       real*8 w,dist(22)
       character*100 f
c local
       integer iflag,ierr,i
       real*8 n1(6),n2(6),n3(6),w1,w2,tol,dx,w3
c
       tol=1.0e-08
c
       iflag=int(dist(1)+0.1)
       if(iflag.eq.6)then
         return
       endif
c
       open(53,file=f,status='old',err=30)
c use linear interpolation, so only need 2 values
       call rrefindline(iflag,w1,n1,ierr)
       if(ierr.ne.0)goto 40
       call rrefindline(iflag,w2,n2,ierr)
       if(ierr.ne.0)goto 40
10     if((w-w1).lt.tol)then
         goto 20
       else if((w.ge.w1).and.(w.le.w2))then
         goto 20
       else
         call rrefindline(iflag,w3,n3,ierr)
         if(ierr.eq.1)goto 20
         if(ierr.eq.0)then
           w1=w2
           w2=w3
           do i=1,6
              n1(i)=n2(i)
              n2(i)=n3(i)
           enddo
           goto 10
         else
           goto 40
         endif
       endif
20     dx=w2-w1
       do i=1,6
          n3(i)=n1(i)*(w2-w)/dx+n2(i)*(w-w1)/dx
       enddo
       dist(2)=n3(1)
       dist(3)=n3(2)
       if((iflag.eq.4).or.(iflag.eq.5))then
         dist(19)=n3(3)
         dist(20)=n3(4)
         if(iflag.eq.5)then
           dist(21)=n3(5)
           dist(22)=n3(6)
         else
           dist(21)=0.0
           dist(22)=0.0
         endif
       else
         dist(19)=0.0
         dist(20)=0.0
         dist(21)=0.0
         dist(22)=0.0
       endif
       close(53)
       return
c
30     write(6,*)'getrefind. error opening the refractive index file:'
       goto 60
40     write(6,*)'getrefind. error reading refractive index file:'
60     write(6,*)f
       write(6,*)'getrefind. Will use the default values from flat.in'
       write(6,*)1,dist(2),dist(3)
1000   format('getrefind. mode',i2,': real=',1PE9.2,' imag=',1PE9.2)
       if((dist(1).eq.4).or.(dist(1).eq.5))then
         write(6,*)2,dist(19),dist(20)
         if(dist(1).eq.5)then
           write(6,*)2,dist(21),dist(22)
         endif
       endif
       close(53)
       return
       end
c
       subroutine rrefindline(iflag,w1,n1,ierr)
c
c read one line of the refractive index file, unit 53
c
       implicit none
c passed
       real*8 n1(6),w1
       integer iflag,ierr
c local
       integer i
c
       if(iflag.eq.4)then
         read(53,*,end=30,err=20)w1,n1(1),n1(2),n1(3),n1(4)
       else if(iflag.eq.5)then
         read(53,*,end=30,err=20)w1,n1
       else
         read(53,*,end=30,err=20)w1,n1(1),n1(2)
       endif
20     if(i.ne.0)then
         if(i.eq.1)i=i+1
       endif
       ierr=i
       return
30     ierr=1 
       end
c

       subroutine mbasename(lwaveloop,wavel,sun,basename)
c make the base name for the output files
c
       implicit none
c passed
       logical lwaveloop
       real*8 wavel,sun
       character basename*13
c local
       integer iwave
       character csun*6
c
       if(sun.lt.0.95)then
          write(csun,'(a4,f2.1)')'.s00',sun
       else if(sun.lt.9.95)then
          write(csun,'(a3,f3.1)')'.s0',sun
       else
          write(csun,'(a2,f4.1)')'.s',sun
       endif
       if(lwaveloop)then
         iwave=int(wavel*1.0e04)
         if(wavel.lt.1.0d0)then
           write(basename(1:13),'(a2,f5.4,a6)')'w0',wavel,csun
         else if(wavel.lt.1.0d1)then
           write(basename(1:13),'(a1,f6.4,a6)')'w',wavel,csun
         else
           write(basename(1:13),'(a1,e6.1,a6)')'w',wavel,csun
         endif
       else
         write(basename(1:13),'(a7,a6)')'flatpsv',csun
       endif
       return
       end
c
       subroutine r1linecoes(wavel,ttr,Fk,o3coe,h2ocoe,Fo,ttf,ttc,
     &aerodist,clddist,refl)
c
c read 1 line of the coes file, unit 52.  wavel is set to -1 if the
c end of the file is reached.
c
c last mod. Aug. 16, 1999...def
c purpose: input the surface reflectivity for each wavelength from coes.
c
       implicit none
c passed
       real*8 wavel,ttr,Fk,o3coe(3),h2ocoe,Fo,ttf,ttc
       real*8 aerodist(22),clddist(22),refl
c local
       integer iflaga,iflagc
c
       iflaga=int(aerodist(1)+0.1)
       iflagc=int(clddist(1)+0.1)
       if(iflaga.lt.4) iflaga=1
       if(iflagc.lt.4) iflagc=1
       if(iflaga.eq.7) iflaga=1
       if(iflagc.eq.7) iflagc=1
       if((iflaga.eq.1).and.(iflagc.eq.1))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),clddist(2),clddist(3),
     &refl
       else if((iflaga.eq.1).and.(iflagc.eq.4))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),clddist(2),clddist(3),
     &clddist(19),clddist(20),
     &refl
       else if((iflaga.eq.1).and.(iflagc.eq.5))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),clddist(2),clddist(3),
     &clddist(19),clddist(20),clddist(21),clddist(22),
     &refl
       else if((iflaga.eq.1).and.(iflagc.eq.6))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),clddist(6),clddist(7),
     &refl
       else if((iflaga.eq.4).and.(iflagc.eq.1))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),clddist(2),clddist(3),
     &refl
       else if((iflaga.eq.4).and.(iflagc.eq.4))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),aerodist(21),aerodist(22),clddist(2),clddist(3),
     &clddist(19),clddist(20),
     &refl
       else if((iflaga.eq.4).and.(iflagc.eq.5))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),clddist(2),clddist(3),
     &clddist(19),clddist(20),clddist(21),clddist(22),
     &refl
       else if((iflaga.eq.4).and.(iflagc.eq.6))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),clddist(6),clddist(7),
     &refl
       else if((iflaga.eq.5).and.(iflagc.eq.1))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),aerodist(21),aerodist(22),clddist(2),clddist(3),
     &refl
       else if((iflaga.eq.5).and.(iflagc.eq.4))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),aerodist(21),aerodist(22),clddist(2),clddist(3),
     &clddist(19),clddist(20),
     &refl
       else if((iflaga.eq.5).and.(iflagc.eq.5))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),aerodist(21),aerodist(22),clddist(2),clddist(3),
     &clddist(19),clddist(20),clddist(21),clddist(22),
     &refl
       else if((iflaga.eq.5).and.(iflagc.eq.6))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(2),aerodist(3),aerodist(19),
     &aerodist(20),aerodist(21),aerodist(22),clddist(6),clddist(7),
     &refl
       else if((iflaga.eq.6).and.(iflagc.eq.1))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(6),aerodist(7),
     &clddist(2),clddist(3),
     &refl
       else if((iflaga.eq.6).and.(iflagc.eq.4))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(6),aerodist(7),
     &clddist(2),clddist(3),clddist(19),clddist(20),
     &refl
       else if((iflaga.eq.6).and.(iflagc.eq.5))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(6),aerodist(7),
     &clddist(2),clddist(3),
     &clddist(19),clddist(20),clddist(21),clddist(22),
     &refl
       else if((iflaga.eq.6).and.(iflagc.eq.6))then
         read(52,*,end=900)wavel,ttr,Fk,o3coe(1),o3coe(2),o3coe(3),
     &h2ocoe,Fo,ttf,ttc,aerodist(6),aerodist(7),
     &clddist(6),clddist(7),
     &refl
       endif
       return
900    wavel=-1.
       return
       end
c
       subroutine chkodndist(dist,ttf)
c
c check the size distribution type and the optical depth to see if they
c are consistant, i.e. if disttype=0, ttf must = 0.
c
       implicit none
c passed
       real*8 dist,ttf
c
       if((int(dist+0.1).eq.0).and.(ttf.gt.0.0))then
         write(6,*)'chkodndist. The size distribution is set to zero',
     &' (no size distribution)'
         write(6,*)'            but the optical depth is > 0.  Will ',
     &'set the optical depth to 0.'
         ttf=0.0d0
       endif
       return
       end
