c $Header: /usr/people/flittner/radtran/flatpsv/src/oneaerop.f,v 1.14 1999/08/16 18:59:07 flittner Exp flittner $
*********************************************************************
      subroutine oneaerop(AMU,AMUP,ANU,ANUP,avgall,ovrinp,const,
     &      	delphi,dthjm,dthjp,phik,Tfine,thet0i,thetj,
     &      	fmatrx,np,g,iflag)
c
c
c last modified: Nov. 18, 1996
c purpose: Add switch for Henyey-Greenstein phase function
c
c last modified: July 22, 1997...def
c purpose: Change the switch for HG phase function to flag for 
c          size dist (iflag).
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c last modified: Apr. 16, 1998...def
c purpose: Rotate matrix from paero2 from scattering plane to vertical plane
c
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
c input 
      integer np,iflag
      real*8 AMUP,ANUP,AMU,ANU,phik,thet0i,thetj,delphi,dthjm,dthjp
      real*8 Tfine(nan,7),const,g
      logical avgall,ovrinp
c output
      real*8 fmatrx(4,4)
c external
      real*8 phg
      external phg
c local
      integer MT,MTP1,jj
      real*8 p(4,4),T1,T2,T3,T4
      real*8 tol,captheta,cos_captheta
      real*8 AMUSQ,AMUMU,SFISQ,SIFI,SISQ,COPSI,SIIN,COOSN,AMUPS,
     &      	CFISQ
      real*8 phitol,fik,YA,onemya
      logical forward,backward,fsbs,debug
c
      captheta=0.0
      tol=1.0e-06
      phitol=1.7453293d-03
      debug=.FALSE.
c
      AMUPS=AMUP*AMUP
      AMUSQ=AMU*AMU
      AMUMU=AMU*AMUP
      fik=phik*dr
      fsbs=.FALSE.
      forward=.FALSE.
      backward=.FALSE.
      if(avgall)then
        if(asin(abs(1.0d0-abs(cos(fik)))).lt.phitol)then
          fsbs=.TRUE.
        endif
c check for backward or forward scattering
        if((abs(AMUP-AMU).lt.tol).and.
     &      	(abs(cos(fik)-1.0d0).lt.tol))then
      	  write(6,'(a8,f8.2,f8.2,f8.2)')'forward',thet0i,thetj,phik
          forward=.TRUE.
          backward=.FALSE.
          phik=0.0d0
        else if((abs(AMUP+AMU).lt.tol).and.
     &      		(abs(cos(fik)+1.0d0).lt.tol))then
      	  write(6,'(a9,f8.2,f8.2,f8.2)')'backward',thet0i,thetj,phik
          forward=.FALSE.
          backward=.TRUE.
          phik=180.0d0
        endif
        if(ovrinp)then
          call pavinp(Tfine,p,thet0i,thetj,phik,delphi,
     &dthjm,dthjp,forward,backward,fsbs,g,iflag)
        else
          call Aerohump(Tfine,p,thet0i,thetj,phik,delphi,
     &dthjm,dthjp,forward,backward,fsbs,g,iflag)
        endif
      else
        COOSN=dcos(fik)
        SIIN=dsin(fik)
        COPSI=ANU*ANUP+AMU*AMUP*COOSN
        SISQ=COPSI*COPSI
        CFISQ=COOSN*COOSN
        SIFI=COPSI*COOSN
        SFISQ=SIIN*SIIN
        cos_captheta=AMUMU+ANUP*ANU*COOSN
        if(iflag.eq.6)then
          do jj=1,4
             fmatrx(1,jj)=0.0d0
             fmatrx(2,jj)=0.0d0
             fmatrx(3,jj)=0.0d0
             fmatrx(4,jj)=0.0d0
          enddo
          fmatrx(1,1)=phg(cos_captheta,g)
          return
        else if(iflag.eq.7)then
          call paero2(Tfine,p,captheta,cos_captheta,fsbs,
     &ANUP,AMUP,AMU,ANU,COOSN,SIIN)
        else
          call paero(Tfine,p,ANUP,AMUP,COOSN,SIIN,COPSI,SISQ,
     &CFISQ,SIFI,SFISQ,AMUMU,AMUSQ,AMUPS,captheta,cos_captheta,
     &AMU,ANU,fsbs)
        endif
      endif
      if(np.eq.1)then
        fmatrx(1,1)=const*(p(1,1)+p(1,2)+p(2,1)+p(2,2))*0.5d0
      else 
        fmatrx(1,1)=const*p(1,1)
        fmatrx(1,2)=const*p(1,2)
        fmatrx(1,3)=const*p(1,3)
        fmatrx(1,4)=const*p(1,4)
        fmatrx(2,1)=const*p(2,1)
        fmatrx(2,2)=const*p(2,2)
        fmatrx(2,3)=const*p(2,3)
        fmatrx(2,4)=-fmatrx(1,4)
        fmatrx(3,1)=const*p(3,1)
        fmatrx(3,2)=const*p(3,2)
        fmatrx(3,3)=const*p(3,3)
        fmatrx(3,4)=const*p(3,4)
        fmatrx(4,1)=const*p(4,1)
        fmatrx(4,2)=-fmatrx(4,1)
        fmatrx(4,3)=const*p(4,3)
        fmatrx(4,4)=const*p(4,4)
      endif
      if(debug)write(6,*)'oneaerop. ',captheta,
     &0.5*(fmatrx(1,1)+fmatrx(1,2)+fmatrx(2,1)+fmatrx(2,2))
c
      return
      end
c ---------------------------------------------------------------------
