c $Header: /usr/people/flittner/radtran/flatpsv/src/pray.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
******************************************************************
      subroutine pray(costh0,sinth0,costh,sinth,cosn,sinn,
     &rmat,aniso,gamma,np)

C
c rmat(m,n) is rayleigth scattering matrix for input 
c angle costh0,output angles costh and cosn.
c
c note that minus signs are used in cos of theta angles because
c phase matrix is computed using a theta angle of 0.0 for a 
c beam traveling straight up and L.O.S. are read-in in the 
c subroutine read ( which means that the beam traveling straight
c up is discribed by the los angle 180.0.
C      AMU = -cos(output angle)
C      ANU = sin(output angle)
C      AMUP = -cos(incident angle)
C      ANUP =  sin(incident angle)
C      AMUSQ = cos()cos()
C      AMUMU = -cos()cos(solar zenith angle)
C      AMUPS = cos(solar zenith angle) squared
C      COOSN = cos(phi_out-phi input).
C
c last modified: Aug. 9, 1997...def
c purpose: change the def. of azimuth angle.  See comments of Rayphase.
c
      implicit none
      include 'consts.cmn'
c passed to Rayphase
      integer np
      real*8 costh,sinth,cosn,sinn,rmat(4,4),costh0,sinth0,gamma
      logical aniso
c aniso is switch for using anisotropic Rayleigh particales with
c anisotropy factor of gamma
c local
      integer m
      real*8 ANUP,AMUP,COOSN,SIIN,COPSI,
     &      SISQ,CFISQ,SIFI,SFISQ,AMUMU,AMUSQ,AMUPS,AMU,ANU
      real*8 const,f
c
      AMUP=costh0
      ANUP=sinth0
      AMUPS=AMUP*AMUP
      if(aniso)then
        f=3.0d0/8.0d0/pi*gamma/(1.0d0+2.0d0*gamma)
        const=3.0d0/8.0d0/pi*(1.0d0-gamma)/(1.0d0+2.0d0*gamma)
      else
        f=0.0d0
        const=3.0d0/8.0d0/pi
      endif
c output theta angle
      AMU=-costh
      ANU=sinth
      AMUSQ=AMU*AMU
      AMUMU=AMU*AMUP
C relative azimuth angle
      COOSN=COSN
      SIIN=-SINN
      COPSI=ANU*ANUP+AMU*AMUP*COOSN
      SISQ=COPSI*COPSI
      CFISQ=COOSN*COOSN
      SIFI=COPSI*COOSN
      SFISQ=SIIN*SIIN
c scattering matrix
      rmat(1,1)=(SISQ)*const
      rmat(1,2)=(AMUSQ*SFISQ)*const
      rmat(1,3)=(AMU*COPSI*SIIN)*const
      rmat(1,4)=0.0D0
      rmat(2,1)=(AMUPS*SFISQ)*const
      rmat(2,2)=(CFISQ)*const
      rmat(2,3)=(-AMUP*COOSN*SIIN)*const
      rmat(2,4)=0.0D0
      rmat(3,1)=(-2.0D0*AMUP*COPSI*SIIN)*const
      rmat(3,2)=(2.0D0*AMU*COOSN*SIIN)*const
      rmat(3,3)=(-AMUMU*SFISQ+SIFI)*const
      rmat(3,4)=0.0D0
      rmat(4,1)=0.0D0
      rmat(4,2)=0.0D0
      rmat(4,3)=0.0D0
      rmat(4,4)=(AMUMU*SFISQ+SIFI)*const
c add isotropic portion for anisotropy
      if(aniso)then
        rmat(1,1)=rmat(1,1)+f
        rmat(1,2)=rmat(1,2)+f
        rmat(2,1)=rmat(2,1)+f
        rmat(2,2)=rmat(2,2)+f
      endif
c 
      if(np.eq.1)then
        rmat(1,1)=0.5d0*(rmat(1,1)+rmat(1,2)+rmat(2,1)+rmat(2,2))
        rmat(1,2)=0.0d0
        rmat(2,1)=0.0d0
        rmat(2,2)=0.0d0
        do m=3,4
           rmat(1,m)=0.0d0
           rmat(2,m)=0.0d0
           rmat(m,1)=0.0d0
           rmat(m,2)=0.0d0
           rmat(m,3)=0.0d0
           rmat(m,4)=0.0d0
        enddo
      endif
      RETURN
      END
***********************************************************************
