c $Header: /usr/people/flittner/radtran/flatpsv/src/rdphas.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
         subroutine rdphas(phasfile,Tfine,QS,omega0,const,g,iflag)
c
c read the phase function file created by phasf
c
c
c last modified: Nov. 18, 1996
c purpose: Add switch for Henyey-Greenstein phase function
c
c last modified: July 22, 1997...def
c purpose: Add option for non-spherical phase function
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c last modified: Jun. 17, 1998...def
c purpose: Mod. the reading of non-spherical phase function file, so
c          that can read the one generated by tmq (extended precision).
c
c
         implicit none
         include 'consts.cmn'
         include 'param.inc'
c
         real*8 Tfine(nan,7),QS,omega0,const,g
         integer iflag
         character phasfile*100
c local
         integer i,j,imode
         real*8 QT,refre(3),refim(3),refmed,anu,sigma(3),rmean(3),a,b
         real*8 alpha,gamma,rmin,rmax,angle,alambda,sum,cosa1,cosa2
         real*8 a1,a2,p1,p2
         logical debug
         character buf*50
c
         debug=.FALSE.
         if(iflag.eq.6)then
           write(61,*)'              HENYEY-GREENSTEIN PHASE ',
     &'FUNCTION WITH FORWARD'
           write(61,3000)'       ASYMMETRY PARAMETER = ',g
           QS=1.0
           const=1.0
           do i=1,7
              do j=1,nan
                 Tfine(j,i)=0.0d0
              enddo
           enddo
         else
c
           open(18,file=phasfile,status='old')
c
           read(18,1000)IFLAG
           IF (IFLAG .EQ. 1) THEN
             READ(18,1010)ANU
             if(debug)write(6,*)'rdphas. anu=',anu
           ELSE if(IFLAG.EQ.2)THEN
             READ(18,1020)sigma(1),rmean(1)
             if(debug)write(6,*)'rdphas. sigma rmean',sigma(1),rmean(1)
           ELSE IF(IFLAG.EQ.3)THEN
             READ(18,1030)a,b,alpha,gamma
             if(debug)write(6,*)'rdphas. a b alpha gamma',a,b,alpha,
     &gamma
           else if(iflag.eq.4)then
             READ(18,1060)(sigma(imode),rmean(imode),imode=1,2)
             if(debug)write(6,*)'rdphas. sigma rmean',sigma(1),rmean(1)
             if(debug)write(6,*)'rdphas. sigma rmean',sigma(2),rmean(2)
           else if(iflag.eq.5)then
             READ(18,1070)(sigma(imode),rmean(imode),imode=1,3)
             if(debug)write(6,*)'rdphas. sigma rmean',sigma(1),rmean(1)
             if(debug)write(6,*)'rdphas. sigma rmean',sigma(2),rmean(2)
             if(debug)write(6,*)'rdphas. sigma rmean',sigma(3),rmean(3)
           else if(iflag.eq.7)then
c skip check of size (assume that have 181 angles)
cc check to see if the number of array elements in Tfine is equall to 
cc 181
c             if(nan.ne.181)then
c               write(6,*)'rdphas. For non-spherical size dist. must ',
c     &'have size of nan=181.'
c               write(6,*)'rdphas. Change the value in param.inc and ',
c     &'recompile.'
c               write(6,*)'rdphas. Will stop now.'
c               stop
c             endif
c read the phase function for non-spherical particles
c skip the header
             write(61,*)'              NON-SPHERICAL P',
     &'ARTICLE SIZE DISTRIBUTION'
             read(18,'(a)')buf
                write(61,'(a)')buf
             read(18,'(4x,f10.6,7x,e10.4,7x,e10.4)')alambda,
     &refre(1),refim(1)
             write(61,3000)'PARTICLE REAL INDEX OF REFRACTION =',
     &refre(1)
             write(61,3000)'PARTICLE IMAGINARY INDEX OF REFRACTION =',
     &refim(1)
c skip to the cross-section info
             read(18,'(a)')buf
             do i=1,5
                read(18,'(a)')buf
                write(61,'(a)')buf
             enddo
             read(18,'(5x,e12.6,7x,e12.6,6x,e12.6,8x,e12.6)')qt,qs,
     &omega0,g
c convert cross-sections from um^2 to cm^2
             qt=qt*1.0e-08
             qs=qs*1.0e-08
c             write(6,'(6x,e12.6,7x,e12.6,6x,e12.6,8x,e12.6)')qt,qs,
c     &omega0,g
             omega0=QS/QT
             if(debug)write(6,*)'rdphas. qt,qs',qt,qs
             if(debug)write(6,*)'rdphas. omega0 g',omega0,g
             refmed=1.0d0
c wavel is in microns, but QS is in square centimeters, so need
c to multiply QS by 1.0d08 square microns/square centimeter.
             const=ALAMBDA*ALAMBDA/(4.0d0*pi*pi*QS*1.0d08)
             read(18,'(a)')buf
             read(18,'(a)')buf
c read phase function
             do i=1,181
                read(18,*)(Tfine(i,j),j=1,7)
                do j=2,7
                   Tfine(i,j)=Tfine(i,j)/const/4.0d0/pi
                enddo
             enddo
             close(18)
             cosa1=cos(Tfine(1,1)*dr)
             do i=1,180
                cosa2=cos(Tfine(i+1,1)*dr)
                sum=sum+0.5*(Tfine(i,2)+Tfine(i+1,2))*
     &(cosa1-cosa2)
             enddo
             write(6,*)'rdphas. NS sum=',sum*2.0*pi
             write(6,*)'rdphas. const=',const
             write(6,*)'rdphas. NS sum=',sum*2.0*pi*const
             write(61,3010)'EXTINCTION COEFFICIENT (cm*cm) =',QT
             write(61,3010)'SCATTERING COEFFICIENT (cm*cm) =',QS
             return
           ENDIF
           READ(18,1040)rmin,rmax
           if(debug)write(6,*)'rdphas. rmin rmax',rmin,rmax
           READ(18,1050)ALAMBDA,refre(1),refim(1)
           if(debug)write(6,*)'rdphas. almabda refre refim',
     &alambda,refre(1),refim(1)
           if(iflag.eq.4.or.iflag.eq.5)then
             READ(18,1080)refre(2),refim(2)
             if(debug)write(6,*)'rdphas. refre refim',refre(2),refim(2) 
             if(iflag.eq.5)READ(18,1080)refre(3),refim(3)
             if(debug.and.iflag.eq.5)write(6,*)'rdphas. refre refim',
     &refre(3),refim(3) 
           endif
           read(18,1055)
c
           READ(18,*) QT,QS
           if(debug)write(6,*)'rdphas. qt,qs',qt,qs
           READ(18,*)g
           if(debug)write(6,*)'rdphas. g',g
           omega0=QS/QT
c wavel is in microns, but QS is in square centimeters, so need
c to multiply QS by 1.0d08 square microns/square centimeter.
           const=ALAMBDA*ALAMBDA/(4.0d0*pi*pi*QS*1.0d08)
           sum=0.0d0
           a1=0.0d0
           p1=0.0d0
           do j=1,nan
c              READ(18,'(1x,f5.1,4(1x,z16))')angle,(Tfine(J,I),I=1,4)
c include phase function for testing
              READ(18,'(1x,f5.1,5(1x,z16))')angle,(Tfine(J,I),I=1,5)
              if(j.eq.1)then
                a1=cos(angle*dr)
c                p1=Tfine(1,5)
                p1=(Tfine(1,1)+Tfine(1,2))*(1.0+a1*a1)+Tfine(1,3)*4.0*a1
              else
                a2=cos(angle*dr)
c                p2=Tfine(j,5)
                p2=(Tfine(j,1)+Tfine(j,2))*(1.0+a2*a2)+Tfine(j,3)*4.0*a2
                sum=sum+0.5d0*(p1+p2)*(a1-a2)
                a1=a2
                p1=p2
              endif
c for old file READ(18,'(f6.1,4(e14.7))')angle,(Tfine(J,I),I=1,4)
           enddo
           refmed=1.0d0
           close(18)
           write(6,*)'rdphas. Integral of phase function over 4pi =',
     &sum*const*pi
c
           if(iflag.eq.1)then
             write(61,*)'              JUNGE TYPE SIZE', 
     &' DISTRIBUTION -- DN/DLOG(R)=R**(-NU)'
             write(61,2000)'WHERE NU =',anu
           else if(iflag.eq.2)then
             write(61,*)
     &'              LOG-NORMAL TYPE SIZE DISTRIBUTION'
             write(61,2000)'WHERE SIGMA =',sigma(1)
             write(61,2000)'MEAN RADIUS (um) =',rmean(1)
           else if(iflag.eq.3)then
             write(61,*)
     &'              MODIFIED GAMMA SIZE DISTRIBUTION '
             write(61,2000)'a =',a
             write(61,2000)'b =',b
             write(61,2000)'alpha =',alpha
             write(61,2000)'gamma =',gamma
           else if(iflag.eq.4)then
             write(61,*)
     &'              BI-MODAL LOG-NORMAL TYPE SIZE DISTRIBUTION'
             write(61,2000)'WHERE SIGMA1 =',sigma(1)
             write(61,2000)'MEAN RADIUS1 (um) =',rmean(1)
             write(61,2000)'WHERE SIGMA2 =',sigma(2)
             write(61,2000)'MEAN RADIUS2 (um) =',rmean(2)
           else if(iflag.eq.5)then
             write(61,*)
     &'             TRI-MODAL LOG-NORMAL TYPE SIZE DISTRIBUTION'
             write(61,2000)'WHERE SIGMA1 =',sigma(1)
             write(61,2000)'MEAN RADIUS1 (um) =',rmean(1)
             write(61,2000)'WHERE SIGMA2 =',sigma(2)
             write(61,2000)'MEAN RADIUS2 (um) =',rmean(2)
             write(61,2000)'WHERE SIGMA3 =',sigma(3)
             write(61,2000)'MEAN RADIUS3 (um) =',rmean(3)
           endif

           write(61,3000)'MINIMUM RADIUS (microns) =',rmin
           write(61,3000)'MAXIMUM RADIUS (microns) =',rmax
           write(61,3000)'MEDIUM REFRACTIVE INDEX =',refmed
           if(iflag.le.3)then
             write(61,3000)'PARTICLE REAL INDEX OF REFRACTION =',
     &refre(1)
             write(61,3000)'PARTICLE IMAGINARY INDEX OF REFRACTION =',
     &refim(1)
           else if(iflag.eq.4)then
             write(61,3000)
     &'PARTICLE REAL INDEX OF REFRACTION of MODE 1=',refre(1)
             write(61,3000)
     &'PARTICLE IMAGINARY INDEX OF REFRACTION of MODE 1=',refim(1)
             write(61,3000)
     &'PARTICLE REAL INDEX OF REFRACTION of MODE 2=',refre(2)
             write(61,3000)
     &'PARTICLE IMAGINARY INDEX OF REFRACTION of MODE 2=',refim(2)
           else if(iflag.eq.5)then
             write(61,3000)
     &'PARTICLE REAL INDEX OF REFRACTION of MODE 1=',refre(1)
             write(61,3000)
     &'PARTICLE IMAGINARY INDEX OF REFRACTION of MODE 1=',refim(1)
             write(61,3000)
     &'PARTICLE REAL INDEX OF REFRACTION of MODE 2=',refre(2)
             write(61,3000)
     &'PARTICLE IMAGINARY INDEX OF REFRACTION of MODE 2=',refim(2)
             write(61,3000)
     &'PARTICLE REAL INDEX OF REFRACTION of MODE 3=',refre(3)
             write(61,3000)
     &'PARTICLE IMAGINARY INDEX OF REFRACTION of MODE 3=',refim(3)
           endif
           write(61,3010)'EXTINCTION COEFFICIENT (cm*cm) =',QT
           write(61,3010)'SCATTERING COEFFICIENT (cm*cm) =',QS
         endif
c         write(61,2100)
c
         return
1000     format(8x,i3,/)
1010     format(6x,f6.4)
1020     format(7x,E11.4,10x,E11.4)
1030     format(3x,E11.4,5x,E11.4,9x,E11.4,9x,E11.4)
1040     format(21x,E11.4,31x,E11.4,/)
1050     format(13x,E11.4,/,27x,E11.4,/,32x,E11.4)
1055     format(/,/,/)
1060     format(/,(8x,E11.4,11x,E11.4,/),(8x,E11.4,11x,E11.4))
1070     format(//,2(8x,E11.4,11x,E11.4,/),(8x,E11.4,11x,E11.4))
1080     format(37x,E11.4,/,42x,E11.4)
2000     format(9x,a43,1x,f8.5)
2100     format(/,/,1x,78('*'))
3000     format(a52,f9.5)
3010     format(12x,a40,1PE12.4)
         end
C########################################################################
