c $Header: /usr/people/flittner/radtran/flatpsv/src/settheta.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
	subroutine settheta(iangtyp,nlos,theta,ierr,thdbnd,phibnd)
c
c define the theta angles to use in solving rte
c
c last modified: Nov. 22, 1996...def
c purpose: use chkint function to check the number of angles requested
c against the total number allowed.
c
c last modified: May 7, 1997...def
c purpose: also set the bounds of the theta bins and phi bins
c
	implicit none
	include 'param.inc'
        include 'consts.cmn'
        integer nlos,i,iangtyp,ierr
        real*8 theta(mlos),thdbnd(mlos+1),phibnd(nfi+1)
c
	integer chkint
	external chkint
	real*8 coulson(32),ang24(24),ang24HB(12),ang26(13),ang28(14)
        real*8 evenmu(20)
	logical prt
c
	data (ang24(i),i=1,24)/5.,15.,25.,35.,45.,55.,65.,70.,75.,
     &80.,85.,87.5,92.5,95.,100.,105.,110.,115.,125.,135.,145.,
     &155.,165.,175/
	data (ang26(i),i=1,13)/5.,15.,25.,35.,45.,55.,65.,70.,75.,
     &80.,85.,87.5,88.9/
	data (ang28(i),i=1,14)/5.,15.,25.,35.,45.,55.,62.5,67.5,
     &72.5,77.5,81.25,83.75,86.25,88.75/
        data (ang24HB(i),i=1,12)/0.975,0.925,0.85,0.75,0.65,0.55,
     &0.45,0.35,0.25,0.1625,0.1,0.0375/
        data (coulson(i),i=1,32)/0.9962,0.98,0.96,0.92,0.84,0.72,
     & 0.64,0.52,
     & 0.40,0.32,0.28,0.20,0.16,0.10,0.06,0.02,
     & -.02,-.06,-.10,-.16,-.20,-.28,-.32,-.40,-.52,-.64,-.72,
     & -.84,-.92,-.96,-.98,-.9962/
        data (evenmu(i),i=1,20)/0.95,0.85,0.75,0.65,0.55,0.45,
     & 0.35,0.25,0.15,0.05,-.05,-.15,-.25,-.35,-.45,-.55,-.65,
     & -.75,-.85,-.95/
c
        prt=.FALSE.
c
        if(prt)write(6,*)'6 = 20 angles'
c
	if(iangtyp.eq.0)then
          nlos=32
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          do i=1,nlos
             theta(i)=acos(coulson(i))/dr
          enddo
        else if(iangtyp.eq.1)then
          nlos=24
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          do i=1,nlos
             theta(i)=ang24(i)
          enddo
        else if(iangtyp.eq.2)then
          nlos=90
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          theta(1)=1.0d0
          do i=2,nlos
             theta(i)=theta(i-1)+2.0d0
          enddo
        else if(iangtyp.eq.3)then
          nlos=24
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          do i=1,nlos/2
             theta(i)=acos(ang24HB(i))/dr
             theta(nlos-i+1)=180.0d0-theta(i)
          enddo
        else if(iangtyp.eq.4)then
          nlos=26
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          do i=1,nlos/2
             theta(i)=ang26(i)
             theta(nlos-i+1)=180.0d0-theta(i)
          enddo
        else if(iangtyp.eq.5)then
          nlos=28
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          do i=1,nlos/2
             theta(i)=ang28(i)
             theta(nlos-i+1)=180.0d0-theta(i)
          enddo
        else if(iangtyp.eq.6)then
          nlos=20
	  ierr=chkint(nlos,mlos)
          if(ierr.ne.0)return
          do i=1,nlos
             theta(i)=acos(evenmu(i))/dr
          enddo
        endif
        do i=nlos+1,mlos
           theta(i)=0.0d0
        enddo
c
c set the theta bounds
c
        thdbnd(1)=0.0d0
        do i=2,nlos
           thdbnd(i)=0.5d0*(theta(i-1)+theta(i))
        enddo
        thdbnd(nlos+1)=180.0d0
c
c set the phi bounds
c
        phibnd(1)=0.0d0
        do i=2,nfi
           phibnd(i)=(dble(i-1)-0.5d0)*(180.0d0/dble(nfi-1))
        enddo
        phibnd(nfi+1)=180.0d0
        end
c
c
	integer function chkint(nlos,mlos)
c
c check the number of angles requested against the max. number of angles
c that can be requested.
c
	implicit none
	integer nlos,mlos
c
        if(mlos.lt.nlos)then
          write(6,1000)nlos,mlos
	  write(6,1010)mlos
          chkint=1
        else
          chkint=0
        endif
1000    format("settheta. requested ",i3," angles but mlos is ",i3)
1010    format("settheta. Must set mlos to ",i3," in param.inc")
	return
	end
