c $Header: /usr/people/flittner/radtran/flatpsv/src/topchap.f,v 1.14 1999/08/16 18:57:14 flittner Exp flittner $
	real*8 function topchap(ps,rpz,Hn)
c
c Calc the distance of the top layer using chapman function.
c
c ps is the tangent height of the beam, rpz is the altitude of the
c second leve of the atmosphere, Hn is the scale height, and C0 is the
c distance such that the total slant path optical depth of this layer 
c would be C0*optical depth/dist (dist is same units as rpz and Hn).
c
	implicit none
        real*8  ps,rpz,amu,dist1,Hn,C0,a,tol
	real*8 chap 
        external chap
        parameter (tol=1.0d-07)
c calc the cosine of the beam at the second level of the atmosphere
        a=ps/rpz
        amu=1.0d0-a*a
        amu=min(1.0d0,amu)
        amu=max(-1.0d0,amu)
        amu=dsqrt(amu)
        if((1.0d0-amu).lt.tol)then
          dist1=1.0d0
        else
          dist1=chap(rpz,Hn,amu)
        endif
        C0=dist1*Hn
	topchap=C0
        return
        end

c************************************************************************
