c $Header: /usr/people/flittner/radtran/flatpsv/src/upitr.f,v 1.14 1999/08/16 18:59:08 flittner Exp flittner $
c ---------------------------------------------------------------------

      subroutine upitr(itest,ndownlos,esi0r,pal,dmu,
     &wa,wr,wc,Pf0mat,Pr0mat,Pc0mat,trans,nz,nlos,np,convrg,itlmax)

C PERFORMS THE UPWARD PASS OF THE GAUSS-SIDEL ITERATION SCHEME
C ITEST - USED TO CHECK FOR CONVERGENCE, IF MORE THAN A 1% CHANGE
C         IN INTENSITY OCCURS BETWEEN THE CURRENT AND LAST ITERATION
C         ANOTHER ITERATION IS PERFORMED.
C NLOS2  - THE INDEX OF THE LINE OF SIGHT ANGLE CLOSEST TO BUT LESS THAN
C         90 DEGREES
C
C last modified: Aug. 7, 1997...def
C purpose: Chang the order of the theta loop, from nadir to limb.

      implicit none
      include 'consts.cmn'
      include 'param.inc'
c
c varibles that are passed
	integer itest,ndownlos,nz,nlos,np,itlmax
	real*8 esi0r(4,mlos,maxnz),
     &pal(mlos,maxnz),dmu(mlos),trans(mlos,maxnz),
     &Pf0mat(4,4,mlos,mlos),Pc0mat(4,4,mlos,mlos),
     &Pr0mat(4,4,mlos,mlos),wa(maxnlayr),wr(maxnlayr),wc(maxnlayr)
	real*8 convrg
c variables that are local
	integer level,layer,lbelow,ilos,m,it,itm
	real*8 enew(4),cfl1,cfl2,T,wal,wrl,c1,delt,wcl
        logical ldown
c external
        integer chkconvrg
        external chkconvrg
c
        ldown=.FALSE.

C THE LEVEL IS SELECTED BY THE L DO LOOP, LAYER IS LL=L-1
C FOR L=NZ, THIS IS THE BOTTOM LAYER. THE INCIDENT INTENSITIES
C          ARE THE SURFACE REFLECTION VALUES
C FOR ALL OTHER LAYERS THERE WILL BE A BOUNDARY TERM AND A TERM FOR 
C          SCATTERING WITHIN THE LAYER. IN A FLAT ATMOSPHERE MODEL
C          THIS BOUNDARY INTENSITY IS SIMPLY THE INTENSITY FROM THE
C          LEVEL DIRECTLY BELOW IN THE SAME DIRECTION
C
C SET THE L.O.S SUCH THAT THETA=90,180(ILOS=NLOS2+1,NLOS) FOR DOWNWARD 
C INTENSITIES THIS THETA  IS THE OUTPUT DIRECTION FOR THE PHASE FUNCTION 
C CALCULATIONS IN THE INTEGRATION OF THE SOURCE FUNCTION
C
C JLOS IS USED FOR THE OUTPUT PHI DIRECTION
C
C FUNCTION SOURCE PERFORMS THE SOURCE TERM INTEGRATION
 
c level = nz 
c value at surface is unchanged since this is the input intensity
c
c now on to the other levels
	do 400 level=nz-1,1,-1
           layer=level
           lbelow=level+1
           wal=wa(layer)
           wrl=wr(layer)
           wcl=wc(layer)
           if(wcl.gt.0.5)then
             itm=itlmax
           else
             itm=1
           endif
           do it=1,itm
              do 80 ilos=nlos,ndownlos+1,-1
                 delt=pal(ilos,level)
                 T=trans(ilos,level)
                 c1=1.0d0-T
                 cfl2=(1.0d0-c1/delt)
                 cfl1=(c1-cfl2)
                 call sourcer(level,layer,lbelow,ilos,esi0r,
     &	dmu,wal,wrl,wcl,cfl1,cfl2,Pf0mat,Pr0mat,Pc0mat,nlos,np,enew)
c m=1
                 enew(1)=enew(1)+esi0r(1,ilos,lbelow)*T
                 if(itest.ne.100.and.enew(1).ne.0.0) then
                   m=1
                   itest=chkconvrg(enew(1),esi0r(1,ilos,level),
     &convrg,level,ilos,m,ldown)
                 end if
                 esi0r(1,ilos,level)=enew(1)
c m=2
                 if(np.gt.1)then
                   enew(2)=enew(2)+esi0r(2,ilos,lbelow)*T
                   if(itest.ne.100.and.enew(2).ne.0.0) then
                     m=2
                     itest=chkconvrg(enew(2),esi0r(2,ilos,level),
     &convrg,level,ilos,m,ldown)
                   end if
                   esi0r(2,ilos,level)=enew(2)
                   if(np.gt.2)then
                     esi0r(3,ilos,level)=enew(3)+esi0r(3,ilos,lbelow)*T
                     if(np.gt.3)esi0r(4,ilos,level)=enew(4)+
     &esi0r(4,ilos,lbelow)*T
                   endif
                 endif
80            continue
           enddo
400	continue 
        return
        end
c ---------------------------------------------------------------------
