c $Header: /misc/krotkov/ASH/EP_HEKLA/src/view.f,v 1.1 2000/01/11 15:00:20 loughman Exp $
C----------------------------------------------------------------------
      subroutine view(ivlev,nlos,np,nz,aniso,avgall,doforward,
     & cosn,costh,deltmu,dmu,dt,esi0,
     & fmatrx,gamma,omega0,pa,pal,wa,wr,QS,refl,
     & rmatrx,sflux,wc,cmatrx,omega0c,QSc,Tfinec,
     & sinn,sinth,sun,Tfine,thd,trans,vtheta,vphi,wavel,
     & vsing0,vout,isfc,npass,ndownlos,esing0,linterpms,rsfc0,rsfc,
     & thdbnd,phibnd)
C----------------------------------------------------------------------
c
c last modified: Nov. 18, 1996
c purpose: add switch for Henyey-Greenstein phase function
C
C last modified: May 5, 1997...def
C purpose: Delete use of Ig.
c
c last modified: May 7, 1997...def
c purpose: Use theta and phi boundaries for averaging the brdf.
c          Also delete use of cpr,cpf,cpr0,cpf0,cpc0,cpc
c
c last modified: July 22, 1997...def
c purpose: Change the switch for HG phase function to flag for 
c          size dist (iflag).
c
c last modified: Nov. 15, 1997...def
c purpose: correct averaging over direct beam fo rthe surface reflectance
c when the sun .le. solar_radius.
c
c last modified: Dec. 30, 1997...def
c purpose: Increase second dimension of Tfine from 4 to 7 so that can
c          use phase functions created by tmatrix program and liou.
c
c
c
      implicit none
      include 'consts.cmn'
      include 'param.inc'
      include 'catmdata.cmn'
      include 'caerphs.cmn'
      include 'ccldphs.cmn'
c constants passed from the calling program
      integer nlos,nz,np,ndownlos
c values calculated before hand that will be used in calculations
      real*8 esi0(4,nfi,mlos,maxnz),Tfine(nan,7),deltmu(mlos)
      real*8 dmu(mlos),esing0(4,nfi,mlos,maxnz)
      real*8 costh(mlos),sinth(mlos)
      real*8 dt(maxnlayr)
      real*8 QS,thd(mlos),sflux(4),wa(maxnlayr),wr(maxnlayr),wavel
      real*8 wc(maxnlayr),omega0,omega0c,Tfinec(nan,7)
      real*8 QSc,refl,thdbnd(mlos+1),phibnd(nfi+1)
c passed in as inputs
      integer ivlev,isfc,npass
      real*8 vtheta,vphi,sun,gamma
      logical doforward,aniso,linterpms
c arrays and other variables that will be used as work-space
      real*8 rmatrx(4,4,nfi,mlos,mlos),pal(mlos,maxnz)
      real*8 trans(mlos,maxnz),pa(maxnz)
      real*8 fmatrx(4,4,nfi,mlos,mlos),cosn(nfi),sinn(nfi)
      real*8 cmatrx(4,4,nfi,mlos,mlos),rsfc0(4,4,nfi,mlos)
      real*8 rsfc(4,4,nfi,mlos,mlos)
c passed back to calling program as output
      real*8 vsing0(4,maxnz),vout(4,maxnz)
c passed to oneaerop
c input
      real*8 AMUP,ANUP,AMU,ANU,phik,thet0i,thetj
      real*8 g
      logical avgall,ovrinp
c passed to extrass
c varibles that are passed as inputs:
      real*8 vcosth
      real*8 cossun
      logical down
cc variables that are local to this subroutine
      integer level,layer,i,j,k,m,n,one,is,ie,il,ic,lp,idirect
      real*8 enew(4),Tr,bndry(4),c1,cf1,cf2,delt,dthjp,dthjm,delphi
      real*8 phasea,phaser,aconst,rconst,cconst,phasec
      integer nlayr
      real*8 vth,vsinth,phi0,thdrange(2),phirange(2),
     &vph,sinsun,vsinn,vcosn,dphi,PaoFov(4),ProFov(4),Pro(4,4),
     &Pao(4,4),wal,wrl,Pco(4,4),PcoFov(4),wcl
      logical prtfas,avgfas,debug
      real*8 solar_radius,phi_spacing,tmpthd(3),tmpphi(3)
      integer nphi,maxnphi
c
c if prtfas=.true., then print out ss phase matrix
c
      prtfas=.FALSE.
      debug=.TRUE.
      one=1
      nlayr=nz-1
      dphi=df/dr
      rconst=3.0d0/16.0d0/pi
c initalize to zero
      do i=1,maxnz
         vout(1,i)=0.0d0
         vout(2,i)=0.0d0
         vout(3,i)=0.0d0
         vout(4,i)=0.0d0
      enddo
      do i=1,maxnz
         vsing0(1,i)=0.0d0
         vsing0(2,i)=0.0d0
         vsing0(3,i)=0.0d0
         vsing0(4,i)=0.0d0
      enddo
c vth=viewing theta angle in radians
      vth=vtheta*dr
      vcosth=cos(vth)
      vsinth=sin(vth)
c sun=solar zenith angle
      cossun=cos(sun*dr)
      sinsun=sin(sun*dr)
c vph = viewing phi angle in radians
      vph=vphi*dr
      vcosn=cos(vph)
      vsinn=sin(vph)

      if(vtheta.lt.90.0d0) then
        down=.TRUE.
      else
        down=.FALSE.
      endif
c compute Single Scatter angle and corresponding phase matrix
      if(rayleigh) then
        amu=-cossun
        call pray(amu,sinsun,vcosth,vsinth,vcosn,vsinn,Pro,
     &aniso,gamma,np)
        if(prtfas)then
          write(6,*)'rayleigh ss matrix for sun=',sun
          write(6,'(4(4(1PE13.4),/))')((Pro(m,n),n=1,4),m=1,4)
        endif
        do m=1,np
           phaser=Pro(m,1)*sflux(1)
           do n=2,np
              phaser=phaser+Pro(m,n)*sflux(n)
           enddo
           ProFov(m)=phaser
        enddo
      else
        do m=1,4
           ProFov(m)=0.0d0
        enddo
      endif
c now for aerosol
      if(aerosol) then
c wavel is in microns, but QS is in square centimeters, so need
c to multiply QS by 1.0d08 square microns/square centimeter.
        aconst=wavel*wavel/(4.0d0*pi*pi*QS*1.0d08)
c the view angles are actually with respect to the local zenith, but with
c 0 deg. as a line going straight down from the top of atmo to sfc, and
c 180 deg. is the line going straight up from sfc to top of atmo.  This is
c the opposite convention that is normally used in formallating the 
c RTE, so must switch sign of cosine of input angle, AMUP, and sign cosine of 
c output angle, AMU.
        AMUP=-cossun
        ANUP=sinsun
        AMU=-vcosth
        ANU=vsinth
        phik=vphi
        thet0i=sun
        thetj=vtheta
c 
        ovrinp=.FALSE.
        avgfas=.FALSE.
        g=gaer
        call oneaerop(AMU,AMUP,ANU,ANUP,avgfas,ovrinp,aconst,dphi,
     &          dthjm,dthjp,phik,Tfine,thet0i,thetj,
     &      	Pao,np,g,iflgaer)
        if(prtfas)then
          write(6,*)'aerosol ss matrix for sun=',sun
          write(6,'(4(4(1PE13.4),/))')((Pao(m,n),n=1,4),m=1,4)
          write(6,*)thetj,0.5*(Pao(1,1)+pao(1,2)+pao(2,1)+pao(2,2))
        endif
        do m=1,np
           phasea=Pao(m,1)*sflux(1)
           do n=2,np
              phasea=phasea+Pao(m,n)*sflux(n)
           enddo
           PaoFov(m)=phasea*omega0
        enddo
      else
        do m=1,4
           PaoFov(m)=0.0d0
        enddo
      endif
      if(cloud) then
        cconst=wavel*wavel/(4.0d0*pi*pi*QSc*1.0d08)
        AMUP=-cossun
        ANUP=sinsun
        AMU=-vcosth
        ANU=vsinth
        phik=vphi
        thet0i=sun
        thetj=vtheta
        ovrinp=.FALSE.
        avgfas=.FALSE.
        g=gcld
        call oneaerop(AMU,AMUP,ANU,ANUP,avgfas,ovrinp,cconst,dphi,
     &          dthjm,dthjp,phik,Tfinec,thet0i,thetj,
     &      	Pco,np,g,iflgcld)
        if(prtfas)then
          write(6,*)'aerosol ss matrix for sun=',sun
          write(6,'(4(4(1PE13.4),/))')((Pco(m,n),n=1,4),m=1,4)
          write(6,*)thetj,0.5*(Pco(1,1)+pco(1,2)+pco(2,1)+pco(2,2))
        endif
        do m=1,np
           phasec=Pco(m,1)*sflux(1)
           do n=2,np
              phasec=phasec+Pco(m,n)*sflux(n)
           enddo
           PcoFov(m)=phasec*omega0c
        enddo
      else
        do m=1,4
           PcoFov(m)=0.0d0
        enddo
      endif
      if(npass.ge.0)then
        if(linterpms)then
          call interpms(nlos,nz,np,esi0,esing0,thd,ndownlos,
     &vtheta,vphi,ivlev,vout(1,ivlev))
        else
c compute multiple scattering angles and corresponding phase matrix
c Rayleigh phase function
          if(rayleigh) then
c by computing delta phi as defined, delta phi = phi out - phi in.
            cosn(1)=cos(vph)
            sinn(1)=sin(vph)
            do k=2,nfi-1
      	       delphi=vph-dble(k-1)*df
      	       cosn(k)=cos(delphi)
      	       sinn(k)=sin(delphi)
            enddo
            delphi=vph-pi
            cosn(nfi)=cos(delphi)
            sinn(nfi)=sin(delphi)
            do i=1,nlos
               amu=-costh(i)
               do k=1,nfi
                  call pray(amu,sinth(i),vcosth,vsinth,cosn(k),
     &sinn(k),rmatrx(1,1,k,i,1),aniso,gamma,np)
               enddo
               if(prtfas)then
                 write(6,*)'rayleigh ms matrix for view angle=',
     &acos(-amu)/dr
                 write(6,'(4(4(1PE13.4),/))')
     &(((rmatrx(m,n,k,i,1),n=1,4),m=1,4),k=1,nfi)
               endif
            enddo
c now do the other half of the hemisphere
c and store in rmatrx as if it is for another output angle, have output
c angle index equal to 2.
            do k=1,nfi-2
               delphi=vph-dble(nfi+k-1)*df
               cosn(k)=cos(delphi)
               sinn(k)=sin(delphi)
            enddo
            do i=1,nlos
               amu=-costh(i)
               do k=1,nfi-2
                  call pray(amu,sinth(i),vcosth,vsinth,cosn(k),
     &sinn(k),rmatrx(1,1,k,i,2),aniso,gamma,np)
               enddo
               if(prtfas)then
                 write(6,*)'rayleigh ms matrix for view angle=',
     &acos(-amu)/dr
                 write(6,'(4(4(1PE13.4),/))')
     &(((rmatrx(m,n,k,i,2),n=1,4),m=1,4),k=1,nfi-2)
               endif
            enddo
c apply the energy normalization constants to the rmatrx
c i=output theta index
c i=1
c j=input theta index
            do j=1,nlos
c k=output delta phi index
               do k=1,nfi
                  do n=1,np
                     do m=1,np
                        rmatrx(m,n,k,j,1)=rmatrx(m,n,k,j,1)
                     enddo
                  enddo
               enddo
            enddo
c i=2
c j=input theta index
            do j=1,nlos
c k=output delta phi index
               do k=1,nfi-2
                  do n=1,np
                     do m=1,np
                        rmatrx(m,n,k,j,2)=rmatrx(m,n,k,j,2)
                     enddo
                  enddo
               enddo
            enddo
          endif
          if(aerosol)then
c Aerosol phase function
c will average over the input direction.  This is different than 
c what was done for the regular angles.  There the averaging was
c done over the output direction.  Should differ slightly, but 
c give close agreement.
            ovrinp=.TRUE.
            g=gaer
            call caerovmsmat(nlos,np,Tfine,dmu,costh,sinth,
     &wavel,QS,thd,omega0,aconst,
     &vtheta,vphi,vcosth,vsinth,fmatrx,avgall,ovrinp,
     &prtfas,g,iflgaer)
          endif
          if(cloud)then
c Cloud phase function
            ovrinp=.TRUE.
            g=gcld
            call caerovmsmat(nlos,np,Tfinec,dmu,costh,sinth,
     &wavel,QSc,thd,omega0c,cconst,
     &vtheta,vphi,vcosth,vsinth,cmatrx,avgall,ovrinp,
     &prtfas,g,iflgcld)
          endif
        endif
      endif
c
c compute the surface reflection matrix for the direct solar beam
c
      if(isfc.gt.0)then
c isfc = 0 & 1 is lambertain surface
        phi0=0.0d0
        i=0
        idirect=1
c use 0.267 deg for the radius of the sun
        solar_radius=0.267d0
        phi_spacing=90.0d0
        maxnphi=3
c compute the thdrange and phirange values for this sza
	call compang(sun,solar_radius,phi_spacing,tmpthd,
     &tmpphi,maxnphi,nphi)
c theta0=sun zenith angle
c thetap=degrees away from the solar zenith angle
c delphi=azimuthally symmetric spacing around the solar zenith at
c	 some angle thetap
        thdrange(1)=tmpthd(3)
        thdrange(2)=tmpthd(1)
        phirange(1)=-tmpphi(2)
        phirange(2)=tmpphi(2)
        if((sun-solar_radius).lt.1.0e-06)thdrange(1)=0.0
        call crsfc(one,one,one,i,np,isfc,vtheta,dmu(1),deltmu(1),
     &vphi,sun,i,phi0,refl,thdrange,phirange,rsfc0(1,1,1,1),idirect)
      endif
c
c now compute single scattering solution for this particular viewing angle
c
      call extrass(np,nz,down,
     &cossun,dt,pa,wa,wr,wc,PaoFov,ProFov,PcoFov,vcosth,ivlev,
     &vsing0,pal,trans,rsfc0,isfc,sflux)
c
c use spline to get the multiple scattered light
c
      if(npass.eq.0)then
        do level=1,nz
           do m=1,np
              vout(m,level)=vsing0(m,level)
           enddo
        enddo
      else
        if(linterpms)then
          do m=1,np
             vout(m,ivlev)=vout(m,ivlev)+vsing0(m,ivlev)
          enddo
        else
c now for multiple scatter and total value of intensity
c compute MS for each layer, from top to viewing level, ivlev.  While doing so,
c compute total intensity at each level.
          if(down)then
c viewing downward radiation
            do m=1,np
               vout(m,1)=0.0d0
            enddo
            if(ivlev.eq.1)return
            is=2
            ie=ivlev
            ic=1
            il=1
            do m=1,np
               bndry(m)=vout(m,is-ic)
            enddo
          else
            if(isfc.gt.0)then
c viewing upward radiation
c calculate the surface rsfc for the diffuse light field
c isfc = 0 & 1 is lambertain surface
              idirect=0
              i=0
              do j=1,ndownlos
                 thdrange(1)=thdbnd(j)
                 thdrange(2)=thdbnd(j+1)
                 do k=1,nfi
                    phi0=dble(k-1)*dphi
                    if(k.eq.1)then
                      phirange(1)=-phibnd(2)
                      phirange(2)=phibnd(2)
                    else if(k.eq.nfi)then
                      phirange(1)=phibnd(nfi)
                      phirange(2)=360.0d0-phibnd(nfi)
                    else
                      phirange(1)=phibnd(k)
                      phirange(2)=phibnd(k+1)
                    endif
                    call crsfc(one,one,one,i,np,isfc,vtheta,dmu(j),
     &deltmu(j),vphi,thd(j),one,phi0,refl,thdrange,phirange,
     &rsfc(1,1,k,j,1),idirect)
                 enddo
                 do k=1,nfi-2
                    phi0=dble(nfi+k-1)*dphi
                    phirange(1)=phi0-(phibnd(nfi-k+1)-dble(nfi-k)*dphi)
                    phirange(2)=phi0-(phibnd(nfi-k)-dble(nfi-k)*dphi)
                    call crsfc(one,one,one,i,np,isfc,vtheta,dmu(j),
     &deltmu(j),vphi,thd(j),one,phi0,refl,thdrange,phirange,
     &rsfc(1,1,k,j,2),idirect)
                 enddo
              enddo
              do j=ndownlos+1,nlos
                 do k=1,nfi
                    do n=1,np
                       do m=1,np
                          rsfc(m,n,k,j,1)=0.0d0
                       enddo
                    enddo
                 enddo
                 do k=1,nfi-2
                    do n=1,np
                       do m=1,np
                          rsfc(m,n,k,j,2)=0.0d0
                       enddo
                    enddo
                 enddo
              enddo
              layer=nz-1
              level=nz
              lp=nz
              wal=0.0d0
              wrl=1.0d0
              wcl=0.0d0
              cf1=1.0d0
              cf2=0.0d0
              call vsource(layer,level,lp,nlos,np,
     &cf1,cf2,dmu,esi0,wal,wrl,wcl,rsfc,rsfc,rsfc,vphi,enew)
              vout(1,nz)=enew(1)+vsing0(1,nz)
              if(np.gt.1) then
                vout(2,nz)=enew(2)+vsing0(2,nz)
                if(np.gt.2)then
                vout(3,nz)=enew(3)+vsing0(3,nz)
                  if(np.gt.3)vout(4,nz)=enew(4)+vsing0(4,nz)
                endif
              endif
            else
              do m=1,np
                 vout(m,nz)=0.0d0
              enddo
            endif
            is=nz-1
            ie=ivlev
            ic=-1
            il=0
            do m=1,np
               bndry(m)=vout(m,is-ic)-vsing0(n,is-ic)
            enddo
          endif
          do level=is,ie,ic
             layer=level-il
             lp=level-ic
             wal=wa(layer)
             wrl=wr(layer)
             wcl=wc(layer)
c only do for one particular direction, vtheta, vphi direction.
             delt=pal(1,level)
             Tr=trans(1,level)
             c1=1.0d0-Tr
             cf2=(1.0d0-c1/delt)
             cf1=c1-cf2
c will compute source function for a layer in direction vtheta, vphi
             call vsource(layer,level,lp,nlos,np,
     &cf1,cf2,dmu,esi0,wal,wrl,wcl,fmatrx,rmatrx,cmatrx,vphi,enew)
             do m=1,np
                vout(m,level)=enew(m)+bndry(m)*Tr+vsing0(m,level)
                bndry(m)=vout(m,level)-vsing0(m,level)
             enddo
             if(debug)write(6,*)'vout(1)',vout(1,level),
     &' enew(1)',enew(1)
          enddo
        endif
      endif
      return
      end
**********************************************************************
