c $Header: /usr/people/flittner/radtran/flatpsv/src/viewr.f,v 1.14 1999/08/16 18:59:07 flittner Exp flittner $
C----------------------------------------------------------------------
	subroutine viewr(ivlev,nlos,np,nz,dmu,esi0r,pal,trans,Fu,
     &vtheta,voutp,wa,wr,wc,fmatrx,rmatrx,cmatrx,
     &thd,ndownlos,linterpms)
C----------------------------------------------------------------------
c calculate the intensity at a given vtheta direction for a 
c isotropic surface flux of Fu
c
	implicit none
        include 'param.inc'
        include 'consts.cmn'
        include 'catmdata.cmn'
c integers passed from the calling program
	integer nlos,nz,np,ndownlos
c values calculated before hand that will be used in calculations
	real*8 esi0r(4,mlos,maxnz),dmu(mlos),wa(maxnlayr)
        real*8 wr(maxnlayr),wc(maxnlayr),fmatrx(4,4,nfi,mlos,mlos)
        real*8 rmatrx(4,4,nfi,mlos,mlos),cmatrx(4,4,nfi,mlos,mlos)
        real*8 thd(mlos)
c passed in as inputs
	integer ivlev
	real*8 vtheta,Fu
	logical linterpms
c arrays and other variables that will be used as work-space
        real*8 pal(mlos,maxnz),trans(mlos,maxnz)
c passed back to calling program as output
	real*8 voutp(4)
c variables that are local to this subroutine
	integer*4 level,lp,layer,j,k,m,n,lev2lay,ic,is,ie
	real*8 Tr,bndry(4),c1,c2,cf1,cf2,delt,sump(4),sumc(4)
        real*8 ep(4),el(4),domega,pn(4,4),wal,wrl,wcl
        real*8 Pr0mat(4,4,mlos,mlos)
        real*8 Pf0mat(4,4,mlos,mlos)
        real*8 Pc0mat(4,4,mlos,mlos)
        logical forview
c
        if(linterpms)then
            call interpmsr(nlos,nz,np,esi0r,thd,ndownlos,
     &vtheta,ivlev,voutp)
        else
c average the phase functions over phi and multiply by domega
         if(rayleigh)then
          forview=.TRUE.
          call avgphsphi(rmatrx,nlos,forview,Pr0mat)
          do j=1,nlos
             domega=dmu(j)*df
             do n=1,np
                do m=1,np
                   Pr0mat(m,n,j,1)=domega*Pr0mat(m,n,j,1)
                enddo
             enddo
          enddo
         endif
         if(aerosol)then
          forview=.TRUE.
          call avgphsphi(fmatrx,nlos,forview,Pf0mat)
          do j=1,nlos
             domega=dmu(j)*df
             do n=1,np
                do m=1,np
                   Pf0mat(m,n,j,1)=domega*Pf0mat(m,n,j,1)
                enddo
             enddo
          enddo
         endif
         if(cloud)then
          forview=.TRUE.
          call avgphsphi(cmatrx,nlos,forview,Pc0mat)
          do j=1,nlos
             domega=dmu(j)*df
             do n=1,np
                do m=1,np
                   Pc0mat(m,n,j,1)=domega*Pc0mat(m,n,j,1)
                enddo
             enddo
          enddo
         endif
c now for multiple scatter and total value of intensity
c compute MS for each layer, from top to viewing level, ivlev.  While doing so,
c compute total intensity at each level.
         do k=1,4
           voutp(k)=0.0d0
           bndry(k)=0.0d0
         enddo

	 if(vtheta.lt.90.0d0) then
          is=2
          ic=1
          lev2lay=-1
         else
          is=nz-1
          ic=-1
	  if(np.gt.1) then
            bndry(1)=Fu/pi/2.0d0
            bndry(2)=Fu/pi/2.0d0
            voutp(1)=bndry(1)
            voutp(2)=bndry(2)
          else
            bndry(1)=Fu/pi
            voutp(1)=bndry(1)
	  endif
          lev2lay=0
         endif
         ie=ivlev
	 do level=is,ie,ic
           lp=level-ic
           layer=level+lev2lay
           wal=wa(layer)
           wrl=wr(layer)
           wcl=wc(layer)
           delt=pal(1,level)
           Tr=trans(1,level)
           c1=1.0d0-Tr
           c2=1.0d0-(c1/delt)
c cf1 is for previous level and cf2 is for current level
           cf1=c1-c2
           cf2=c2
c zero-out the sums for this layer
           do n=1,np
              sump(n)=0.0d0
              sumc(n)=0.0d0
           enddo
c calculate the source function at each level using the phase matrix
c for this layer
           do j=1,nlos
              do n=1,np
                 do m=1,np
                    pn(m,n)=wal*Pf0mat(m,n,j,1)+
     &wrl*Pr0mat(m,n,j,1)+wcl*Pc0mat(m,n,j,1)
                 enddo
              enddo
              do m=1,np
                 ep(m)=esi0r(m,j,lp)
                 el(m)=esi0r(m,j,level)
              enddo
              do n=1,np
                 do m=1,np
                    sump(n)=sump(n)+pn(n,m)*ep(m)
                    sumc(n)=sumc(n)+pn(n,m)*el(m)
                 enddo
              enddo
           enddo
           do m=1,np
              voutp(m)=Tr*bndry(m)+cf1*sump(m)+cf2*sumc(m)
           enddo
           do m=1,np
              bndry(m)=voutp(m)
           enddo
	 enddo
        endif
	return
	end
c ---------------------------------------------------------------------
