c $Header: /usr/people/flittner/radtran/flatpsv/src/cncldlay.f,v 1.14 1999/08/16 18:57:13 flittner Exp flittner $
       subroutine cncldlay(ttc,dtaumax,zcldtop,zcldbot,zmod,maxnz,k,
     &nlay3)
c
c calculate the number of cloud layers using the thick atmo method
c
c ttc is the total optical thickness of the cloud
c dtaumax is the maximum delta tau of atmosphere outside the cloud
c zcldtop is the alt. of the top of the cloud
c zcldbot is the alt. of the bottom of the cloud
c zmod is array of model atmosphere altitudes
c maxnz is the dimension of zmod
c k is current index of zmod
c nlay3 is the total number of cloud layers
c
        implicit none
c
        integer k,maxnz,nlay3
        real*8 ttc,dtaumax,zcldtop,zcldbot,zmod(maxnz)
        integer mn
        parameter (mn=40)
	real*8 tcloudtop,tcloudbot,sumc,tol,dtau(mn),dtaucm,dzdttc
        integer jcount,nlay(mn),ntau,ntaumax,nn,i,index,ntotal,j
        logical debug
c
        data debug/.FALSE./
        data tol/1.0d-05/
	data tcloudtop/0.5d0/
	data tcloudbot/0.5d0/
        data dtaucm/2.0d0/
c dtaucm is the maximum thickness of any cloud layer
c
	write(6,1000)zcldtop,zcldbot
1000    format(1x,'cncldlay. cloud top=',f7.2,' (km);cloud bot=',
     &f7.2,' (km)')
	jcount=0
	dtau(1)=dtaumax
        sumc=0.0d0
        if(ttc.le.tcloudtop+tcloudbot)then
          nn=1
          dtau(nn)=dtaumax
          ntau=nint(ttc/dtau(nn))
          dtau(nn)=ttc/dble(ntau)
          nlay(1)=ntau
          ntotal=ntau
          if(debug)write(6,*)nlay(1),ntau,dtau(nn)
        else
          nn=1
          dtau(nn)=dtaumax
          ntau=nint((tcloudtop)/dtau(nn))
          nlay(nn)=ntau
          sumc=tcloudtop
          if(debug)write(6,*)nlay(nn),ntau,dtau(nn),sumc
          do while((0.5d0*ttc)-sumc.gt.dtaumax)
             ntaumax=10
             if(jcount.gt.2) ntaumax=5
             jcount=jcount+1
             nn=1+nn
             dtau(nn)=0.05d0*2.0d0**(jcount-1)
             ntau=nint((0.5d0*ttc-sumc)/dtau(nn))
             ntau=min(ntau,ntaumax)
             if(dtau(nn).gt.dtaucm)then
               dtau(nn)=dtaucm
               ntau=nint((0.5d0*ttc-sumc)/dtau(nn))
             endif
             if(ntau.eq.0)then
               dtau(nn)=0.5d0*ttc-sumc
               ntau=1
               nlay(nn)=ntau
               sumc=sumc+ntau*dtau(nn)
               if(debug)write(6,*)nlay(nn),ntau,dtau(nn),sumc
               goto 20
             else if((sumc+ntau*dtau(nn)-0.5d0*ttc).gt.tol)then
               ntau=nint((0.5d0*ttc-sumc)/dtau(nn))
               dtau(nn)=(0.5d0*ttc-sumc)/dble(ntau)
               nlay(nn)=ntau
               sumc=sumc+ntau*dtau(nn)
               if(debug)write(6,*)nlay(nn),ntau,dtau(nn),sumc
               goto 20
             else
               nlay(nn)=ntau
               sumc=sumc+ntau*dtau(nn)
               if(debug)write(6,*)nlay(nn),ntau,dtau(nn),sumc
             endif
          enddo
20        ntotal=nlay(1)
          do i=nn,2,-1
             index=2*nn-i+1
             nlay(index)=nlay(i)
             dtau(index)=dtau(i)
             ntau=nlay(index)
             ntotal=ntotal+ntau*2
             sumc=sumc+ntau*dtau(index)
             if(debug)write(6,*)nlay(index),ntau,dtau(index),sumc
          enddo
          nn=2*nn
          dtau(nn)=dtaumax
          ntau=nint((ttc-sumc)/dtau(nn))
          dtau(nn)=(ttc-sumc)/dble(ntau)
          nlay(nn)=ntau
          ntotal=ntotal+ntau
          sumc=sumc+ntau*dtau(nn)
          if(debug)write(6,*)nlay(nn),ntau,dtau(nn),sumc
        endif
c check to see if larger than maxnz
        if(nn+1+k.gt.maxnz)then
          write(6,*)'cncldlay. nz is greater that maxnz'
          write(6,*)'cncldlay. you must recompile atmstr.x with ',
     &'maxnz greater than or equal to',nn+1+k,'.'
          stop
        end if
c do the cloud using isotropic drop density in the cloud
        zmod(k)=zcldtop
        dzdttc=(zcldtop-zcldbot)/ttc
        do i=1,nn
           do j=1,nlay(i)
              k=k+1
              zmod(k)=zmod(k-1)-dzdttc*dtau(i)
           enddo
        enddo
        k=k+1
        zmod(k)=zcldbot
        nlay3=ntotal
        return
        end
c***********************************************************************
