;		Process all days for a month of interest
monthofinterest=10
csite='NASA/GSFC, Maryland, USA'
;csite='Santa Cruz, Bolivia'
;               Average WT,k AOT, NO2
;chan='317'
;chan='325'
;chan='332'
chan='440'

szamin=00 & szamax=70.0		; SZA limits 
;aot440m_min=0.2		;  select ALL measurements with AERONET AOT440 > 0.1                      
aot440m_min=0.01		;  select ALL measurements with AERONET AOT440 > 0.1 for figure 4 and 5                     
;aot440m_min=0.39	;  Table 1 and 2: select only measurements with AERONET AOT440 > aot440m_min in read_newoutput_alldays

;		AERONET SSA errors:
aer_tau440=[0.03,0.2,0.5,1.,2.] & aer_errssa=[0.07,0.05,0.03,0.02,0.02]
;		MFRSR   tau_abs errors:
mfrsr_text325=[0.03,0.2,0.8,1.5] & mfrsr_errtabs33=[0.01,0.01,0.02,0.02] & mfrsr_errtabs70=[0.007,0.008,0.013,0.013]

max_dw=10.00   ; currently has no effect (max allowed derivative dw/dtime)
mode='screen'          ; screen output
;mode='print'            ; PostScrip output
;xmin=10. & xmax=24    & ymin=0.7 & ymax=1.00  & x1=17. & y1=0.99 
xmin=0. & xmax=24    & ymin=0.7 & ymax=1.00  & x1=17. & y1=0.87 
sza_offset=+0.01	; sza labels offset
n_top=+1             	;labels at bottom

ddfit_tolerance=0.01  ;		!!! dd fit should be better than 0.01 	!!!

;               averaged W results file file
header1=  'year mm dd doy UT SZA AOT'+chan+'  N   W'+chan+'    k'+chan+'    AOT440   W440  k440  n440  AOT670  W670   k670   n670   Trans   NO2'                         
header2=  '                                                  *10^3           *10^3                                                          [DU]'  
print,header1 & print,header2


;		PROCESS ALL DAYS
;read,'enter initial year,month,day (yyyy,mm,dd) ',year_plot,month_plot,day_plot
;year_plot=2006 & month_plot=7 & day_plot=14		; start of combined NO2 data record
;cday=string(day_plot,format='(i2)') & cmonth=string(month_plot,format='(i2)') & cyear=string(year_plot,format='(i4)')
;yymmdd=[year_plot,month_plot,day_plot]  & doy=fdayofyear(yymmdd) 	;doy=julday(yymmdd)  ;& print,'doy=',doy
;year_count_input=double(year_plot + doy/365.25)   ;& print,'year_count_input=',year_count_input   ; year count calculation


if chan eq '300nm' then begin
 fname='output.dt300_1022' 
end else if chan eq '305' then begin
  fname='output.dd305nm_gsfc.txt20120912'            
end else if chan eq '311' then begin
  fname='output.dd311nm_gsfc.txt20120912'            
end else if chan eq '317' then begin
  fname='output.dd317nm_gsfc.txt20120912'            
end else if chan eq '325' then begin
  fname='output.dd325nm_gsfc.txt'            
end else if chan eq '332' then begin
  fname='output.dd332nm_gsfc.txt'    
end else if chan eq '368' then begin
  fname='output.dd368nm_gsfc.txt'    
end else if chan eq '440' then begin
  fname='output.dd440nm_gsfc.txt'    
end

;		with NO2
read_newoutput_alldays_no2,monthofinterest,aot440m_min,fname,ddfit_tolerance,szamin,szamax, day_plot,month_plot,year_plot, hour_aeronet,min_aeronet,sec_aeronet,day_aeronet,month_aeronet,dayofyear,year,$	
cv,cvf,cvc,rv,rvf,rvc,s,sf,sc, aot1020m,aot870m,aot670m,aot500m,aot440m,aot380m,aot340m,$
aot440,aot670,aot870,aot1020,w440,w670,ri440,ri670,ri870,ri1020,rr440,rr670,rr870,rr1020,$
sza_mfrsr,hour_mfrsr,min_mfrsr,sec_mfrsr, ozone,pres_md12, m_tau325,m_w325,a_tau325,dd_calc325,dd_mfrsr325,niter325, ind,count_day,m_total,m_dif,ct_meas,n_real,k_real,no2

print,'count_day=',count_day
print,'ind='
print,ind

timeofday_aeronet=double(hour_aeronet + min_aeronet/60. + sec_aeronet/3600.)
timeofday_mfrsr=double(hour_mfrsr + min_mfrsr/60. + sec_mfrsr/3600.)

;	MFRSR errors
err_wm33=interpol(mfrsr_errtabs33,mfrsr_text325,m_tau325(ind))/m_tau325(ind)
err_wm70=interpol(mfrsr_errtabs70,mfrsr_text325,m_tau325(ind))/m_tau325(ind)
err_wm=err_wm33 &  for i=0,n_elements(ind)-1 do err_wm(i)=interpol([err_wm33(i),err_wm70(i)],[33,70],sza_mfrsr(ind(i)))


close,4 & openw,4,'matchup_'+fname+'_aotge'+string(aot440m_min,format='(f4.2)') 
printf,4,' 				MATCHUP RETRIEVALS' &  printf,4,header1 & printf,4,header2


ind_start=0 & count_match=0	; initialize indices

next_retrieval:		; RETURN HERE FOR NEXT AERONET RETRIEVAL

ind_start=ind_start+count_match

print,'ind_start=',ind_start

if ind_start ge count_day -1 then begin
close,4
stop
endif


;			selection of all MFRSR data around individual AERONET inversion
w_all=where ( hour_aeronet(ind) eq hour_aeronet(ind(ind_start))  $
       and min_aeronet(ind) eq  min_aeronet(ind(ind_start))   $
       and sec_aeronet(ind) eq  sec_aeronet(ind(ind_start))   $
       and dayofyear(ind) eq  dayofyear(ind(ind_start))   $
       and year(ind) eq  year(ind(ind_start))   $
        , count_match)		; count all bad and good ) retrievals for a given AERONET inversion time
print,'count_match=',count_match

if count_match le 1  then goto,next_retrieval

;		Average only good MFRSR  retrievals
w=where ( hour_aeronet(ind) eq hour_aeronet(ind(ind_start))  $
       and min_aeronet(ind) eq  min_aeronet(ind(ind_start))   $
       and sec_aeronet(ind) eq  sec_aeronet(ind(ind_start))   $
       and dayofyear(ind) eq  dayofyear(ind(ind_start))   $
       and year(ind) eq  year(ind(ind_start))   $
      and m_w325(ind) gt 0.0      $		;   do not count filled SSA values (failed retrrievals)
        , count_match_good)
print,count_match_good
;print,'ind(w)=',ind(w)
if count_match_good le 1  then goto,next_retrieval


;	If passed both filters start averaging
ind_match=ind(w) ;& print,'ind_match=',ind_match

tsza=moment(sza_mfrsr(ind_match)) & msza=tsza(0)
tno2=moment(no2(ind_match)) & mno2=tno2(0)
tm_tau325=moment(m_tau325(ind_match)) & mm_tau325=tm_tau325(0)
ta_tau325=moment(a_tau325(ind_match)) & ma_tau325=ta_tau325(0)		; 15min AERONET TAU extrapolated to 325nm
tm_total =moment(m_total(ind_match))  & mm_total =tm_total(0)		; mean total transmittance (MFRSR) at 325nm


sa380440=0.0 & sa440870=0.0 & sa_prime=0.0

for i=0,count_match_good -1 do begin

;	ACTUAL AERONET MEASURED AOT interpolated to MFRSR time 
aeronet_wave=[340.,380.,440.,500.,675.,870.] & aeronet_aot_meas=[aot340m(ind_match(i)),aot380m(ind_match(i)),aot440m(ind_match(i)),aot500m(ind_match(i)),aot670m(ind_match(i)),aot870m(ind_match(i))] ;&  print,aeronet_aot_meas

; 	AERONET EXTRAPOLATION TO 325nm
ctitle='Extrapolated AERONET AOT  '+string(dayofyear(ind_match(0)),format='(i4)')+string(timeofday_aeronet(ind_match(i)),format='(f9.2)')
cmonth=string(month_aeronet(ind_match(0)),format='(i2)')
cday  =string(day_aeronet(ind_match(0)),format='(i2)')
cyear=string(year(ind_match(0)),format='(i4)')

ctitle=csite+' Month='+cmonth+'  Day='+cday+'  Year='+cyear+ '	Time='+string(timeofday_aeronet(ind_match(i)),format='(f9.2)')
plot_aot_spec_all,chan,m_tau325(ind_match(i)),mode,'spectral_aot.ps',ctitle,count_match_good ,timeofday_aeronet(ind_match(i)),aeronet_wave,aeronet_aot_meas,a_tau325(ind_match(i)),aeronet_aot_meas_mfrsr,delta_aot_fit,sigma_aot_fit,a380440,a440870,a_prime
sa380440=sa380440+a380440 &  sa440870=sa440870+a440870 &  sa_prime=sa_prime+a_prime
endfor

sa380440=sa380440/count_match_good
sa440870=sa440870/count_match_good
sa_prime=sa_prime/count_match_good

tm_w325=moment(m_w325(ind_match)) & mm_w325=tm_w325(0)
tk=moment(k_real(ind_match)) & mk325=tk(0)
tn=moment(n_real(ind_match)) & mn325=tn(0)



;			PRINT OUTPUT FILE
print,year(ind_match(0)),month_aeronet(ind_match(0)),day_aeronet(ind_match(0)),dayofyear(ind_match(0)),timeofday_aeronet(ind_match(0)),msza,mm_tau325,count_match_good,$
mm_w325,1000.*mk325,aot440m(ind_match(0)),w440(ind_match(0)), 1000.*ri440(ind_match(0)),rr440(ind_match(0)),$
sa380440,sa440870,sa_prime,$
;                                                N      W325      k325   AOT440  W440    k440    n440
format='(i4,1x,2(i2,1x),i3,1x,2(f4.1,1x),f5.3,4x,i3, 6X,F5.3,4X,F6.2,3X,f5.3,2x,f5.3,3x,f6.3,3x,f6.3,4x,3(f6.3,4x))'

printf,4,year(ind_match(0)),month_aeronet(ind_match(0)),day_aeronet(ind_match(0)),dayofyear(ind_match(0)),timeofday_aeronet(ind_match(0)),msza,mm_tau325,count_match_good,$
mm_w325,1000.*mk325,aot440m(ind_match(0)),w440(ind_match(0)), 1000.*ri440(ind_match(0)),rr440(ind_match(0)),$
                    aot670m(ind_match(0)),w670(ind_match(0)), 1000.*ri670(ind_match(0)),rr670(ind_match(0)),$
                           mm_total,mno2,$
;                                                N   W368      k325       AOT440  W440    k440    n440    Trans    NO2
format='(i4,1x,2(i2,1x),i3,1x,2(f4.1,1x),f5.3,1x,i3, 1X,F5.3,1X,F6.3,3X,2(f5.3,1x,f5.3,1x,f6.2,1x,f6.3,2x),f7.4,2x,f5.2)'


goto,next_retrieval


if mode ne 'screen' then device,/close

close,4			;   close averaged file


stop
end
