      subroutine aerosol(no_mie,iaermod,iaertype,lam,refrr1,refri1,
     &refrr2,refri2,sigma1,rmean1,Nc1,sigma2,rmean2,Nc2,qext440)
C************************************************************************
C	FUNCTION: 1) create flat.in template for given PSD
c       if (no_mie =.false. ) then
c       2)  calculate the aerosol extintion coefficient at 440 nm
C
C	HISTORY: 
C	Modified 03/23/2002 to change normalization wavelength to 440nm
C	Modified 05/16/2001 to eliminate common blocks
C************************************************************************     
      implicit none
      
      logical no_mie
      integer k,nstr,iaertype,iaermod,n

      real qext440
      real refrr1(12),refri1(12),refrr2(12),refri2(12),lam(12)
      real sigma1,rmean1,Nc1,sigma2,rmean2,Nc2
      
      parameter (nstr=24) 

      character*25 buff,faerosol,ff
      character*80 str(nstr),buf(12)
                  
C---------start

      faerosol='aerosol.phs'
      ff='flat.in_aer440'
      
      open(10,file=ff,status='old')
      do k=1,nstr
         read(10,'(a)') str(k)
      enddo      
      close(10)
C-----------open input file
      
      open(10,file=ff,status='unknown') 
           
C----------modify the input file

      write(10,'(a)') str(1)
      write(10,'(i2)') iaertype
      if(iaertype.eq.2) then
c     write(10,'(2f12.6)') refrr1(12),refri1(12)	! lam(12)=0.5um
      write(10,'(2f12.6)') refrr1(9),refri1(9)		! lam(9)=0.44um
      else if(iaertype.eq.4) then
c     write(10,'(4f12.6)') refrr1(12),refri1(12),refrr2(12),refri2(12)
      write(10,'(4f12.6)') refrr1(9), refri1(9), refrr2(9), refri2(9)
      endif
c     write(10,'(4f12.5)') rmean1/100.0,rmean1+sigma1*5,rmean2/100.0,
      write(10,'(4f12.5)') 0.05, 15.0, 0.05, 15.0                        

      if(iaertype.eq.2) write(10,'(2f12.5)') sigma1,rmean1
      if(iaertype.eq.4) write(10,'(6f12.5)') sigma1,rmean1,Nc1,
     &sigma2,rmean2,Nc2
      write(10,'(a)') (str(k),k=6,nstr)
      close(10)
      
	if (no_mie) then
      write(*,*) 'NO MIE CALCULATIONS AT 440NM'
      qext440=-999.999
      return

     	else

C----------call the Gauss-Seidel program
      call system('cp flat.in_aer440 flat.in')
      call system('rm -f aerosol.phs')
      call system('rm -f miecalc.dat')
      call system('flatpsv.x')
      
      WRITE(*,*) 'MIE CALCULATIONS AT 440 NM COMPLETED'
      WRITE(*,*)                                        
      
C----------open output file 
    
      open(10,file=faerosol,status='old')
      
C----------read in the aerosol extinction coefficient
      if(iaertype.eq.2) n=8
      if(iaertype.eq.4) n=12
      read(10,'(a)') (buf(k),k=1,n)
      read(10,'(a,e12.4)') buff,qext440

      close(10)
      
C---------remove a file containing the phase matrix
      
      call system('rm -f aerosol.phs')
      call system('mv miecalc.dat miecalc.dat_440')
      call system('mv phasf.out phasf_440.out')

      endif
      
      return
      end
       
      
      
