;CODE TO READ THE MONTHLY SHADOWBAND DATA (DIRECT & DIFFUSE)
;and merge to the FULL cimel data (SSA, PSD, etc)
;for only the clear days (read from Nick's file irradcal440_clear
;this is for +/- 1/2 hour of the cimel time

;++++++++++History++++++++++
;select sza < 65 at V0_chan_alldays.pro
;2012-03-08				add climatological ozone(AERONET ozone)
;ncol=155  -> ncol=156
;changed directory
;/home/krotkov/UVMFRSR527/GSFC_DOME/V0/irradcal332nmaeronet.clearno2

;02,07,2005,Locations=GSFC,long=-76.840,lat=38.992,elev=87,Nmeas=4,PI=Brent__Holben,Email=Brent.N.Holben@nasa.gov
;Level 2.0 Almucantar Retrievals, Version 2


;*****************read clear shadowband data***************************
ch0='325'
chan=ch0+'nm'

file =  'irradcal'+ch0+'nmaeronet.clearno2'
file2 = '120801_121115_GSFC.dubovik'
file3 = 'oct_cc_uv_IDL_00_00.final' ;merged file (UVMFRSR 582)

;***read file3
reader_merged_v3,file3,chan,year_m,month_m,day_m,hour_m,minute_m,second_m,sza_m,am_m,nm_chan_m,wav340_m,wav380_m,wav440_m,wav500_m, $
wav670_m,wav870_m,wav1020_m,aot340_m,aot380_m,aot440_m,aot500_m,aot670_m,aot870_m,aot1020_m,water_m,pres_true_m,pres_aeronet_m,ozone_aeronet_m, $
ozone_true_m,toms_ler_m,delta_time_m,delta_time_no2_m,no2_aeronet_m,no2_true_m,errno2_m
;among variables, we will use
;year_m, month_m, day_m, hour_m, minute_m, second_m
;ozone_aeronet_m
ozone_aeronet = string(ozone_aeronet_m,format='(F0.3)')
;****

OPENR,1, file
a=STRARR(1)
b=FLTARR(30)

readf,1,a		;read headers
;readf,1,a		;read headers

day=INTARR(100000) & month=INTARR(100000) & year=INTARR(100000)
hour=INTARR(100000) & minute=INTARR(100000) & second=INTARR(100000)
nm300=fltarr(3,100000) & nm305=nm300 & nm311=nm300 & nm317=nm300
nm325=nm300 & nm332=nm300 & nm368=nm300 &sza=fltarr(100000)

dhour=FLTARR(100000)
uvavolt=FLTARR(100000)
uvaflux=FLTARR(100000)

i=0
;Loop reads in i lines of data...

WHILE (NOT EOF(1)) DO BEGIN

  READF,1,b
  day(i)=FIX(b(3)) & month(i)=FIX(b(2)) & year(i)=FIX(b(1))
  hour(i)=b(4) & minute(i)=b(5) & second(i)=b(6)
  dhour(i)=hour(i) + minute(i)/60. + second(i)/3600.
  i=i+1

ENDWHILE
 CLOSE,/all
day=day(0:i-1)
month=month(0:i-1)
year=year(0:i-1)
dhour=dhour(0:i-1)
hour=hour(0:i-1) & minute=minute(0:i-1) & second=second(0:i-1)

;**********now read in shadowband data as a string (so as to add the cimel data to the end)***********
OPENR,1,file
  a=' '
  readf,1,a
;  readf,1,a
  sband=strarr(1,i)
  readf,1,sband
  close,1

snum=i-1		;number of lines in the shadowband file

;;***checking
;for ij=0, 10 do print, sband(0,ij)
;stop
;file = 'F:\CLEO_work\MFRSR\krotkov\V0_20110909\irradcal440nmaeronet.clearno2_total'
;openr, 1, file
;for ik=0L, file_lines(file)-1L do begin


;***checking
print,'now reading CIMEL data'


;***********************now read in full CIMEL  data***********************
;read it in as a string to get number of lines
openr,1, file2

hdr=' '
readf,1,hdr		;read header
readf,1,hdr		;read header
readf,1,hdr		;read header
readf,1,hdr		;read header

c=0.
a=' '
strcimel=strarr(1,200000)
while (not eof(1)) do begin		;get # of rows
  readf,1,a
  strcimel(0,c)=a
  c=c+1.
endwhile
close,1
strcimel=strcimel(0,0:c-1)

;now open it again and read it as an array
openr,1,file2

hdr=' '
readf,1,hdr		;read header
readf,1,hdr		;read header
readf,1,hdr		;read header
readf,1,hdr		;read header

ncol=156
nrows=c-1
a=fltarr(ncol,nrows)

readf,1,a & close,1
cimel=a

dd=reform(a(0,*))
mm=reform(a(1,*))
yy=reform(a(2,*))
hh=reform(a(3,*))
mn=reform(a(4,*))
sc=reform(a(5,*))
ctime=hh+mn/60. + sc/3600.
dayofyear=reform(a(6,*))
ssa441=reform(a(37,*)) ;for preventing errors in the ARIZONA code
ref441=reform(a(46,*))

;**************************************now make matchups****************
openw,2,'junk.txt'
print,'now making matchups'
print,' '
print,' '
print,' '
print,' '
print,'#'

for n=0,n_elements(ctime)-1 do begin		;for each cimel retrieval

   ;*****get closest shadowband data*******for 1/2 hour
   w=where ((day eq dd(n)) and (month eq mm(n)) and (year eq yy(n)) and (dhour ge ctime(n)-0.5) and (dhour le ctime(n)+0.5))
   print,n_elements(w),dd(n),mm(n),yy(n)

;   if (n_elements(w) lt 2) then goto,out
   if (n_elements(w) lt 2 or ssa441(n) eq -999 or ref441(n) eq -999) then goto,out
   ;Yes. Just drop AERONET retrievals if it has REF -999, and do not use AERONET data for SZA > 70deg.(2011-10-17)

   if (n_elements(w) ge 2) then begin

    printf,2,strcimel(n)
    printf,2,fix(n_elements(w))

    for nn=0,n_elements(w)-1 do begin			;just w closest measurements
      idx = where(day_m eq day(w(nn)) and month_m eq month(w(nn)) and year_m eq year(w(nn)) and $
        hour_m eq hour(w(nn)) and minute_m eq minute(w(nn)) and second_m eq second(w(nn)), idx_cnt)
      if idx_cnt ne 1 then stop
      printf,2,sband(w(nn))+'  '+ozone_aeronet(idx)
    endfor
   endif

out:
endfor
close,/all

END
