      subroutine surfmodel(salb440v2,imod,lam,refl)
C***********************************************************************
C	AUTHOR: Alexander P. Vasilkov
C
C	FUNCTION:
C	
c       WARNING:  no spectral dependence in surf albedo = AERONET V2 albedo at 440nm
C       MODIFIED: May 09 2007 to use AERONET V2 surf albedo at 440nm
C	HISTORY:  Developed October 11, 2000
C
C***********************************************************************
      implicit none
            
      integer i,j,nmodel,imod,ibuf      
      real lam(12),refl(12), salb440v2

      character*60 buf1(3),buf2(13)
      
      parameter(nmodel=6)
        
C---------------read in data on surface reflectance models

      open(30,file='surf_model.dat',status='old')
      read(30,'(a)') (buf1(j),j=1,3)
      do i=1,nmodel
      if(i.ne.imod) then
         read(30,'(a)') (buf2(j),j=1,13)
      else
         read(30,*) ibuf
         do j=1,12 
            read(30,*) lam(j),refl(j)
         enddo
      endif
      enddo

c-----------   assign AERONET albedo to refl  - nk
         do j=1,12		! assign AERONET V2 albedo at 440nm to all wavelengths
            refl(j)=salb440v2
         enddo

      close(30)
      end
